/*
    Data area of dd__o starter.
    Comments with '$' as the first letter
    describe appearence of parameters
    on the screen.
*/

/*$t Starter*/
typedef struct _dd__o_Data {
  /*$t Initial point*/
  double *Tdef;		/*$ 1-%Time | - n Time | "0" */
  double *T;		/*$ %Time | - n @Time { $Time} | "0" %LCode(Time) */
  double *Tau;		/*$ -2 | - n __S | "0" %LCode(Time) */
  int lenT;		/*$  1 | - n __lenT | "0" */		/* len in bytes of  *Tau */
  double *X;		/*$ -2 | - n __X | "0" %LCode(Phase) */
  int lenX;		/*$  1 | - n __lenX | "0" */		/* len in bytes of  *X */
  double *DT;		/* Init point: delays */
			/*$=_slv %Delay | - n @Delay { $Delay} | "0" %LCode(Delay) */
			/*$ %Delay | + n @Delay { $Delay} | "0" %LCode(Delay) */
  double *P;		/* Init point: parameters components */
			/*$=_slv %Par | - n @Par { $Par} | "0" %LCode(Par) */
			/*$ %Par | + n @Par { $Par} | "0" %LCode(Par) */
  char *Active;		
                        /*$    %Par | - n _ActivePar | "0" */

  /*$t Discretization data*/
  int nmesh;		/*$ 1 | + n MeshPoints | "50" */
  int nmeshold;		/*$ 1 | - n __m | "50" %Code(SPECCL_DIM) */

  /*$t Jacobian data*/
  double dx;		/* differentiation increment  */
			/*$ 1 | + n Increment | "0.00001" */

  /*$t User defined functions*/    
  char *ActiveUserTest;	        /*  LOCCL_AUS  */
			/*$=_slv %UserFunc | - S ignore detect monitor | @UserFunc { $UserFunc} | "0" %Code(SPECCL_AUS) */
			/*$ %UserFunc | + S ignore detect monitor | @UserFunc { $UserFunc} | "0" %Code(SPECCL_AUS) */
  /*$t Interpolation method */
  int Jinterpol;	/* 0 - linear, 1 - cubic spline */
			/*$ 1 | + S linear cubic_spline | Interpolation | "0" */
  /*$t Set initial point*/
  FuncPar(int,SetInitPoint,(int ip, struct _dd__o_Data * _ptr));
			/*$=_slv 1 | - f SetInitPoint | "" */
			/*$ 1 | + f SetInitPoint | "" */
  double* time0;       /* hidden fields to call SetInitPoint */
  			/*$ -10-%Time | - n @Time { $Time} | "0" */
  double* coord0;       
  			/*$ -10-%Phase | - n @Phase { $Phase} | "0" */
} dd__o_Data, * dd__o_DataPtr;

