/*
    Data area of m__ns starter.
    Comments with '$' as the first letter
    describe appearence of parameters
    on the screen.
*/

/*
   Note the user is allowed to access invisible Active field.
   To support this ActivePar macro is provided.
   Its parameter is external (i.e. visible to the user)
   name of parameter of dynamical system.
   The only problem is that all external names (expanded and explisit)
   must differ from 'ActivePar'
*/
#define ActivePar(parname) _ptr->Active[&(parname)-_ptr->P]=TRUE;

/*$t Starter*/
typedef struct _m__ns_Data {
  /*$t Iteration data*/
  int itmap;		/* number of iterations  */
			/*$ 1 | + n Superposition | "1" %Code(SPECCL_MSUP) */
  /*$t Initial point*/
  double *T;		/*$ %Time | - n @Time { $Time} | "0" %LCode(Time) */
  double *X;		/* Init point: phase components */
			/*$ %Phase | + n @Phase { $Phase} | "0" %LCode(Phase) */
  double *P;		/* Init point: parameters components */
			/*$ %Par | + N @Par { $Par} | "0" %LCode(Par) */
  char *Active;		/*$ %Par | - n _ActivePar | "0" */

  /*$t Singular Solver data*/
  double eps;		/* null-vector tolerance  */
			/*$ 1 | + n SingTolerance | "0.001" */
  /*$t Jacobian data*/
  double dx;		/* differentiation increment  */
			/*$ 1 | + n Increment | "0.00001" */
  /*$t=nn Branch switch data*/
  int branch;		/* branch to switch */
			/*$=nn 1 | + s primary secondary | Branch | "1" */
			/*$    1 | - s primary secondary | Branch | "1" */
  /*$t Monitor singularities*/
  char  *ActiveSing;	/* Max number of secant iterations */
			/*$ 8 | + s no yes | Degenerate_NS(%Phase-2) 1:1(%Phase-2) Fold-NS(%Phase-3) Flip-NS(%Phase-3) Double_NS(%Phase-4) 1:2(%Phase-2) 1:3(%Phase-2) 1:4(%Phase-2)| "1" */
  int *TypeTestFunc;     /* 0 - ignore value (locate change of sign only); 1 - full test */
                        /*$ 8 | - n | "1,1,1,1,1,1,1,0" */
  int *ZeroTestFunc;    /* 0 - NOT zeroed; 1 - zeroed */
                        /*$=bt 4 | - n | "0,1,1,0" */      
                        /*$=zh 4 | - n | "0,0,1,0" */      
                        /*$    4 | - n | "0" */
  /*$t User defined functions*/    
  char *ActiveUserTest;	/*$ %UserFunc | + S ignore detect monitor append | @UserFunc { $UserFunc} | "0" %Code(SPECCL_AUS) */
  /*$t Eigenvalues*/
  int eigcomp;          /* compute eigenvalues */
                        /*$ 1 | + s no yes | Compute | "1" */
  /*$t Set initial point*/
  FuncPar(void,SetInitPoint,(struct _m__ns_Data * _ptr));
			/*$ 1 | + f SetInitPoint | "" */

} m__ns_Data, * m__ns_DataPtr;


