/*
    Data area of continuator.
    Comments with '$' as the first letter
    describe appearence of parameters
    on the screen.
*/

/*$t Continuer*/
typedef struct {
  void * X0;		/* First point supplied by a starter */
			/*$ -1 | - n | "0" */
  void * V0;		/* First tangent vector supplied by a starter */
			/*$ -1 | - n | "0" */
  char * ActiveSing;	/* Activeness of singularities supplied by starter */
			/*$ -1 | - n | "0" */
  int * TypeTestFuns;	/* Types of test functions */
                        /*$ -1 | - n | "0" */
  int * ZeroTestFuns;	/* Test functions that have to be zeroed at the first point */
                        /*$ -1 | - n | "0" */
  char * ActiveUserTest;/* Activeness of user test functions supplied by starter */
			/*$ -1 | - n | "0" */

  /*$t Continuation data*/
  double h0;		/* Initial step */
			/*$ 1 | + n InitStepsize | "0.01" */
  double hcur;		/* Current step; the user cannot change it */
			/*$ 1 | + o CurrentStepsize | "0.01" */
  double hmin;		/* Min step */
			/*$ 1 | + n MinStepsize | "0.00001" */
  double hmax;		/* Max step */
			/*$ 1 | + n MaxStepsize | "0.1" */

  /*$t Corrector data*/
  int maxit;		/* max number of iterations  */
			/*$ 1 | + n MaxIter | "10" */
  int maxnewt;		/* max number of Newton iterations  */
			/*$ 1 | + n MaxNewtonIter | "10" */
  double epsx;		/* variable tolerance  */
			/*$ 1 | + n VarTolerance | "0.00001" */
  double epsf;		/* function tolerance  */
			/*$ 1 | + n FuncTolerance | "0.0001" */
  double epsz;		/* test function tolerance  */
			/*$ 1 | + n TestTolerance | "0.001" */
  int IterTestFuns;     /* max number of iterations for test functions */
		        /*$ 1 | + n MaxIterTest | "20" */

  /*$t Stop data*/
  int maxnpt;		/* max number of points in one direction  */
			/*$ 1 | + n MaxNumPoints | "100" */
  int nclosed;		/* number of points between closure check  */
			/*$ 1 | + n BeforeClosureCheck | "10" */
  int nadapt;		/* number of points between adaptation  */
			/*$=h 1 | + n BetweenAdaptation | "1" */
			/*$=lp 1 | + n BetweenAdaptation | "1" */
			/*$=bt 1 | + n BetweenAdaptation | "1" */
			/*$=cp 1 | + n BetweenAdaptation | "1" */
			/*$=zh 1 | + n BetweenAdaptation | "1" */
			/*$=dh 1 | + n BetweenAdaptation | "1" */
			/*$=gh 1 | + n BetweenAdaptation | "1" */
			/*$=lc 1 | + n BetweenAdaptation | "3" */
			/*$=pd 1 | + n BetweenAdaptation | "3" */
			/*$=hom 1 | + n BetweenAdaptation | "3" */
			/*$=pde1 1 | + n BetweenAdaptation | "1" */ 
			/*$=ns 1 | + n BetweenAdaptation | "1" */ 
			/*$ 1 | - n BetweenAdaptation | "0" */

  /*$t Output data*/
  int outlevel;         /*$ 1 | + n OutLevel | "0" */
} ContData, * ContDataPtr;

