/*
    Data area of __ep starter.
    Comments with '$' as the first letter
    describe appearence of parameters
    on the screen.
*/

/*
   Note the user is allowed to access invisible Active field.
   To support this ActivePar macro is provided.
   Its parameter is external (i.e. visible to the user)
   name of parameter of dynamical system.
   The only problem is that all external names (expanded and explisit)
   must differ from 'ActivePar'
*/
#define ActivePar(parname) _ptr->Active[&(parname)-_ptr->P]=1;

/*$t Starter*/
typedef struct ___ep_Data {
  /*$t Initial point*/
  double *T;		/*$ %Time | - n @Time { $Time} | "0" %LCode(Time) */
  double *X;		/* Init point: phase components */
			/*$ %Phase | + n @Phase { $Phase} | "0" %LCode(Phase) */
  double *P;		/* Init point: parameters components */
			/*$ %Par | + N @Par { $Par} | "0" %LCode(Par) */
  char *Active;		
                        /*$=bp %Par | - n _ActivePar | "0" 255 */
                        /*$    %Par | - n _ActivePar | "0" */

  /*$t=o Corrector data*/
  int maxit;		/* max number of iterations  */
			/*$=o 1 | + n MaxIter | "10" */
			/*$   1 | - n MaxIter | "10" */
  int maxnewt;		/* max number of Newton iterations  */
			/*$=o 1 | + n MaxNewtonIter | "10" */
			/*$   1 | - n MaxNewtonIter | "10" */
  double epsx;		/* variable tolerance  */
			/*$=o 1 | + n VarTolerance | "0.00001" */
			/*$   1 | - n VarTolerance | "0.00001" */
  double epsf;		/* function tolerance  */
			/*$=o 1 | + n FuncTolerance | "0.0001" */
			/*$   1 | - n FuncTolerance | "0.0001" */
  /*$t Jacobian data*/
  double dx;		/* differentiation increment  */
			/*$ 1 | + n Increment | "0.00001" */
  /*$t=bp Branch switch data*/
  int branch;		/* branch to switch */
			/*$=bp 1 | + s primary secondary | Branch | "1" */
			/*$    1 | - s primary secondary | Branch | "1" */
  /*$t Monitor singularities*/
  char *ActiveSing;	        /*  */
			/*$ 3 | + s no yes | Branching Limit_point Hopf(%Phase-2) | "1" */
  int *TypeTestFunc;    /* 0 - ignore value (locate change of sign only); 1 - full test */
                        /*$ 3 | - n | "1,1,0" */     
  int *ZeroTestFunc; 
                        /*$=bp 3 | - n | "1,0,0" */
                        /*$    3 | - n | "0" */
  /*$t User defined functions*/    
  char *ActiveUserTest;	        /*  LOCCL_AUS  */
			/*$ %UserFunc | + S ignore detect monitor append | @UserFunc { $UserFunc} | "0" %Code(SPECCL_AUS) */
  /*$t Eigenvalues*/
  int eigcomp;          /* compute eigenvalues */
                        /*$ 1 | + s no yes | Compute | "1" */
                        
  /*$t!bp Set initial point*/
  FuncPar(void,SetInitPoint,(struct ___ep_Data * _ptr));
			/*$=bp 1 | - f SetInitPoint | "" */
			/*$ 1 | + f SetInitPoint | "" */
} __ep_Data, * __ep_DataPtr;
