Exported 1.3 Dec 23, 1998 12:27 PM
Class:  MapGen 311
System: rotor (periodically forced ODEs)
&= Phase
x,y,Q
&
&= Par
u,E,D,beta,omega0,gamma0,gammaC
&
&= Time
t
&
&= Rhs
/********************************************************************
PUT THE FILE radau5.c FROM THE SUBDIRECTORY Maps
OF DIRECTORY examples INTO THE DIRECTORY WHERE 
YOU RUN CONTENT BEFORE COMPILING RHS !!!
********************************************************************/
RHS(x,y,Q,u,E,D,beta,omega0,gamma0,gammaC,&x',&y',&Q');
&
&= Func
/*Definition of the F77 equivalent type*/
  typedef long int integer;
  typedef double doublereal;
  typedef long int logical;
  typedef /* Subroutine */ int (*S_fp)();
  typedef int /* Unknown procedure type */ (*U_fp)();

/*F77 Equivalent constants*/
#define TRUE_  (1)
#define FALSE_ (0)

/*F77 Equivalent functions*/
#define abs(x) ((x) >= 0 ? (x) : -(x))
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))

/* Common Block Declarations */

struct {
    doublereal xout;
} intern_;

#define intern_1 intern_

/* Table of constant values */

static integer c__1 = 1;
static integer c__2 = 2;

double u, E, D, beta0, omega0, gamma0, gammac;

/* * * * * * * * * * * * * * * * * * * * * * * * * * */
/* --- DRIVER FOR RADAU5 FOR THE ROTOR PROBLEM ---   */
/* * * * * * * * * * * * * * * * * * * * * * * * * * */
/* link dr2_radau5 radau5 decsol dc_decsol */

void RHS (double xxx, double yyy, double QQQ, 
          double uuu, double EEE, double DDD, double beta000,
          double omega000, double gamma000, double gammaccc,
          double *resx, double *resy, double *resQ)
{
    /* Local variables */
    static integer ijac, idid;
    static doublereal beta;
    static integer imas, ipar[20];
    static doublereal xend, atol, rpar[20];
    static integer itol, iout;
    static doublereal rtol, h__;
    static integer i__, j, n;
    static doublereal alpha;
    static integer mljac;
    static doublereal x, y[3];
    extern /* Subroutine */ int fampl_();
    static integer mujac, mlmas, mumas;
    static doublereal r0, r1, r2, r3, r4, r5, r6, r7, r8, r9;
    extern /* Subroutine */ int radau5_(integer *, U_fp, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, U_fp, integer *, integer *, integer *, U_fp, 
	    integer *, integer *, integer *, doublereal *, integer *, U_fp, 
	    integer *);
 

    extern /* Subroutine */ int bbampl_(), jbampl_(), solout_();

    u=uuu;
    E=EEE;
    D=DDD;
    beta0=beta000;
    gamma0=gamma000;
    gammac=gammaccc;
    omega0=omega000;

/* --- DIMENSION OF THE SYSTEM */
    n = 3;

/* --- COMPUTE THE JACOBIAN NUMERICALLY */
    ijac = 0;

/* --- JACOBIAN IS A FULL MATRIX */
    mljac = 3;
    mujac = 3;

/* --- DIFFERENTIAL EQUATION IS IN EXPLICIT FORM */
    imas = 0;
    mlmas = 3;
    mumas = 3;

/* --- OUTPUT ROUTINE IS NOT USED DURING INTEGRATION */
    iout = 0;

/* --- INITIAL VALUES */
    x = 0.0;
    y[0] = xxx;
    y[1] = yyy;
    y[2] = QQQ;

/* --- ENDPOINT OF INTEGRATION */
/*<         XEND=2*PI >*/
    xend = 8.0*atan(1.0);
/* --- REQUIRED TOLERANCE */
/*<         RTOL=1.0D-7>*/
    rtol = 1e-7;
/*<         ATOL=1.0D-9*RTOL >*/
    atol = rtol * 1e-9;
/*<         ITOL=0 >*/
    itol = 0;
/* --- INITIAL STEP SIZE */
/*<         H=1.0D-6  >*/
    h__ = 1e-6;
/* --- SET DEFAULT VALUES */
/*<         DO 10 I=1,20 >*/
    for (i__ = 1; i__ <= 20; ++i__) {
/*<         IPAR(I)=0 >*/
	ipar[i__ - 1] = 0;
/*<   10    RPAR(I)=0.D0 >*/
/* L10: */
	rpar[i__ - 1] = 0.;
    }
/* --- THE RETURN VALUE */
/*<         IDID=0   >*/
    idid = 0;
/* --- CALL OF THE SUBROUTINE RADAU5 */
/*<    >*/
    radau5_(&n, (U_fp)fampl_, &x, &xend, y, &h__, &rtol, &atol, (U_fp)jbampl_,
	     &ijac, &mljac, &mujac, (U_fp)bbampl_, &imas, &mlmas, &mumas, 
	    rpar, ipar, (U_fp)solout_, &idid);
    
    *resx=y[0];
    *resy=y[1];
    *resQ=y[2];

    return;
}


/*<         SUBROUTINE SOLOUT (NR,XOLD,X,Y,CONT,LRC,N,IRTRN) >*/
/* Subroutine */ int solout_(integer *nr, doublereal *xold, doublereal *x, 
	doublereal *y, doublereal *cont, integer *lrc, integer *n, integer *
	irtrn)
{
   return 0;
} 


/*<         SUBROUTINE FAMPL(N,X,Y,F) >*/
/* Subroutine */ int fampl_(integer *n, doublereal *x, doublereal *y, 
	doublereal *f)
{
    /* Local variables */
    static doublereal F1,F2,DE,c,s;

/* --- RIGHT-HAND SIDE OF THE ROTOR PROBLEM ---- */
/*<         IMPLICIT REAL*8 (A-H,O-Z) >*/
/*<         REAL*8 Y(N),F(N) >*/

    /* Parameter adjustments */
    --f;
    --y;

    /* Function Body */

    s = sin( *x);
    c = cos( *x);

    /* adjusted phase variables y[1]=x; y[2]=y; y[3]=Q */

    F1=-y[1]-2*D*y[2]+E*y[3]*y[3]*s;
    F2=gamma0*(u-y[3]/omega0)-gammac-beta0*E*s;
    DE=1-E*E*c*c;

    /* RHS */

    f[1]=y[2]/y[3];
    f[2]=(1/DE)*(F1-E*c*F2)/y[3];
    f[3]=(1/DE)*(-E*c*F1+F2)/y[3];

    return 0;
} /* fampl_ */



/*<         SUBROUTINE JBAMPL(N,X,Y,DFY,LDFY) >*/
/* Subroutine */ int jbampl_(integer *n, doublereal *x, doublereal *y, 
	doublereal *dfy, integer *ldfy)
{
    return 0;

} /* jbampl_ */


/*<         SUBROUTINE BBAMPL(N,B,LB) >*/
/* Subroutine */ int bbampl_(integer *n, doublereal *b, integer *lb)
{
    return 0;

} /* bbampl_ */

#include "radau5.c"
&
&m Misc
 der5= 1 1 1 1 1 show=2 sm=1
&
&w Win
num=1 mask=1
 flag=128 title=2D graphic
  pos=(204,337)-(576,450) scr=(1152,900) col=(-1000,-1001)
  class=1 unique=0
   func=1 cur=0
   -8
   8
   0
   x
   1 0 1 1 0 0 
   -8
   8
   0
   y
   1 0 1 1 0 0 
   point=(-1000,3,-1) trace=(-1000,2,-1) path=(-1000,2,0)
   options=(-1000,2,-1,128,0)
   undo=2
     0 1 0 1
     -20 20 -20 20
&
&d diagrams
 outlevel=3
 D diagram
  u unt
   unt=2
  t defstagen
   defstagen=1,1
  F filt m__o O O
   from=1,1 to=5000,500 step=1,1
   n=4
   relclass=0: 1 [0,-1]
   relclass=1: 1 [0,-3]
   relclass=2: 0
   relclass=3: 0
   spec= 1 3 7 0
  p _iter.h
   fields=3
    field2 dim=1 1000
   expr=0
   win=836 699 2 1153 901 0
  p m__o.h
   fields=7
    field0 dim=1 1
    field1 dim=0
    field2 dim=1 0
    field3 dim=3 -2.27 1.34831460674157 0.16
    field4 dim=7 1.167 0.2 0.01 2 1
      4 0.1
    field5 dim=0
    field6 unique=0 selected=0
   expr=0
   win=858 2 16 1153 901 0
  c0  inPoint->Orbit (+)
   types=1,1
   p m__o.h
   fields=7
    field0 dim=1 1
    field1 dim=0
    field2 dim=1 0
    field3 dim=3 -2.25 1.34831460674157 0.16
    field4 dim=7 1.167 0.2 0.01 2 1
      4 0.1
    field5 dim=0
    field6 unique=0 selected=0
   expr=0
   p _iter.h
   fields=3
    field2 dim=1 1000
   expr=0
   f m__o
   from=1,1 to=5000,500 step=1,1
   n=4
   relclass=0: 1 [0,-1]
   relclass=1: 1 [0,-3]
   relclass=2: 0
   relclass=3: 0
   spec= 1 3 7 0
   u=0
   cl=4 7
   p 0
   1
   -1: 0
   -3: -2.25 1.34831460674157 0.16
   0:
   0:
   p 0
   1
   -1: 1
   -3: -2.9311552295055 0.338583093075648 1.03344811454366
   0:
   0:
   p 0
   1
   -1: 2
   -3: -3.31868495795236 -0.833577781980264 1.02608967791543
   0:
   0:
   p 0
   1
   -1: 3
   -3: -3.36510252097557 -1.8364890402163 1.03300721758959
   0:
   0:
   p 0
   1
   -1: 4
   -3: -3.16254678401068 -2.71699984782141 1.05024800541326
   0:
   0:
   p 0
   1
   -1: 5
   -3: -2.67139245932929 -3.52247443619013 1.07992714430609
   0:
   0:
   p 0
   1
   -1: 6
   -3: -1.71656108402447 -4.23198643262745 1.12960736611818
   0:
   0:
   p 0
   1
   -1: 7
   -3: 0.0148069818449576 -4.54162560919192 1.21029777114775
   0:
   0:
   p 0
   1
   -1: 8
   -3: 2.4312846927263 -3.37971249352369 1.30849710375892
   0:
   0:
   p 0
   1
   -1: 9
   -3: 3.24339745535622 -0.023788486337058 1.31780310858659
   0:
   0:
   p 0
   1
   -1: 10
   -3: 0.894667005726296 2.24938926079852 1.19303836110675
   0:
   0:
   p 0
   1
   -1: 11
   -3: -1.5240912294463 1.87253710438572 1.08496186331803
   0:
   0:
   p 0
   1
   -1: 12
   -3: -2.76404658490149 0.631439031518171 1.03855977433143
   0:
   0:
   p 0
   1
   -1: 13
   -3: -3.26267595848287 -0.579387449838243 1.02638288154993
   0:
   0:
   p 0
   1
   -1: 14
   -3: -3.37349432450158 -1.61902939989633 1.03065818484174
   0:
   0:
   p 0
   1
   -1: 15
   -3: -3.2262336497401 -2.52347529691427 1.0455862176519
   0:
   0:
   p 0
   1
   -1: 16
   -3: -2.80908893612121 -3.34457905528741 1.07205409619271
   0:
   0:
   p 0
   1
   -1: 17
   -3: -1.9804032672172 -4.08623878666482 1.11636671959808
   0:
   0:
   p 0
   1
   -1: 18
   -3: -0.448280945121071 -4.54179846887642 1.18951514906222
   0:
   0:
   p 0
   1
   -1: 19
   -3: 1.90690388921211 -3.84016183533554 1.28893937953681
   0:
   0:
   p 0
   1
   -1: 20
   -3: 3.37245804532485 -0.839311328094371 1.33003581794025
   0:
   0:
   p 0
   1
   -1: 21
   -3: 1.53586821302957 2.01313527676306 1.22426471992963
   0:
   0:
   p 0
   1
   -1: 22
   -3: -1.09361668649835 2.08483563824618 1.10301487735514
   0:
   0:
   p 0
   1
   -1: 23
   -3: -2.56826841659799 0.913837275768639 1.0451032239091
   0:
   0:
   p 0
   1
   -1: 24
   -3: -3.19012315707076 -0.328653078513905 1.02747571725965
   0:
   0:
   p 0
   1
   -1: 25
   -3: -3.3684058978208 -1.40551316758569 1.02896551180391
   0:
   0:
   p 0
   1
   -1: 26
   -3: -3.27318306120261 -2.33564142757273 1.04174021001776
   0:
   0:
   p 0
   1
   -1: 27
   -3: -2.91960836482988 -3.17265980977999 1.06546619033219
   0:
   0:
   p 0
   1
   -1: 28
   -3: -2.19578997142389 -3.93741408707949 1.10527347987725
   0:
   0:
   p 0
   1
   -1: 29
   -3: -0.838709595467279 -4.49282075390304 1.1715300349358
   0:
   0:
   p 0
   1
   -1: 30
   -3: 1.38696665500634 -4.15088778100933 1.26835197690624
   0:
   0:
   p 0
   1
   -1: 31
   -3: 3.31289223108675 -1.6056309845924 1.33346204705632
   0:
   0:
   p 0
   1
   -1: 32
   -3: 2.11087547931006 1.64526381004926 1.2533992030602
   0:
   0:
   p 0
   1
   -1: 33
   -3: -0.630868957819982 2.23282982490516 1.12309991913554
   0:
   0:
   p 0
   1
   -1: 34
   -3: -2.34681787126833 1.17755336020166 1.05301271873022
   0:
   0:
   p 0
   1
   -1: 35
   -3: -3.10240376665473 -0.0862517672281741 1.02934977207726
   0:
   0:
   p 0
   1
   -1: 36
   -3: -3.35104779682389 -1.19935009335327 1.02790552404285
   0:
   0:
   p 0
   1
   -1: 37
   -3: -3.30512578025706 -2.15621093788661 1.03865698408424
   0:
   0:
   p 0
   1
   -1: 38
   -3: -3.00619217729325 -3.00974130867067 1.06004675224793
   0:
   0:
   p 0
   1
   -1: 39
   -3: -2.36855949592728 -3.79223890644503 1.09613220550957
   0:
   0:
   p 0
   1
   -1: 40
   -3: -1.15920653397724 -4.41549001543572 1.15641310647231
   0:
   0:
   p 0
   1
   -1: 41
   -3: 0.911401008844618 -4.34155050754213 1.24872864108433
   0:
   0:
   p 0
   1
   -1: 42
   -3: 3.11576111650818 -2.26509108341619 1.32994948511603
   0:
   0:
   p 0
   1
   -1: 43
   -3: 2.5782760928333 1.18325640968665 1.27827536307475
   0:
   0:
   p 0
   1
   -1: 44
   -3: -0.158395763017036 2.30745204639193 1.14423177021949
   0:
   0:
   p 0
   1
   -1: 45
   -3: -2.10670360643373 1.41341137283649 1.06204302747703
   0:
   0:
   p 0
   1
   -1: 46
   -3: -3.00246326420682 0.141457487801741 1.03192683668108
   0:
   0:
   p 0
   1
   -1: 47
   -3: -3.32314873055761 -1.00520546244403 1.02744170672827
   0:
   0:
   p 0
   1
   -1: 48
   -3: -3.32370058543551 -1.98884871321809 1.03629596263925
   0:
   0:
   p 0
   1
   -1: 49
   -3: -3.07140713945606 -2.85930942373827 1.05571312023967
   0:
   0:
   p 0
   1
   -1: 50
   -3: -2.50340397534777 -3.65642764663368 1.08878840717066
   0:
   0:
   p 0
   1
   -1: 51
   -3: -1.41423878764718 -4.32573927569325 1.14411591817561
   0:
   0:
   p 0
   1
   -1: 52
   -3: 0.504055853475147 -4.44394392628261 1.23138787208005
   0:
   0:
   p 0
   1
   -1: 53
   -3: 2.84486460239107 -2.78865985955459 1.32210930899908
   0:
   0:
   p 0
   1
   -1: 54
   -3: 2.91570532396705 0.68380202287527 1.29747938577864
   0:
   0:
   p 0
   1
   -1: 55
   -3: 0.293752505544387 2.30971500303989 1.16499977123587
   0:
   0:
   p 0
   1
   -1: 56
   -3: -1.86014561414947 1.61240142346624 1.07170408126929
   0:
   0:
   p 0
   1
   -1: 57
   -3: -2.89545415207546 0.346631497547628 1.03503905035515
   0:
   0:
   p 0
   1
   -1: 58
   -3: -3.28723325973422 -0.829186369306413 1.02751346557468
   0:
   0:
   p 0
   1
   -1: 59
   -3: -3.33058800798518 -1.83838302896655 1.03462479142843
   0:
   0:
   p 0
   1
   -1: 60
   -3: -3.11722893935284 -2.72560998834278 1.05241576482994
   0:
   0:
   p 0
   1
   -1: 61
   -3: -2.60375524729862 -3.53538535066057 1.08314041430608
   0:
   0:
   p 0
   1
   -1: 62
   -3: -1.60806373069066 -4.23596124384948 1.13456762611437
   0:
   0:
   p 0
   1
   -1: 63
   -3: 0.177897789631354 -4.48661539906786 1.21715226741937
   0:
   0:
   p 0
   1
   -1: 64
   -3: 2.56167103256523 -3.17179341066832 1.31261924645216
   0:
   0:
   p 0
   1
   -1: 65
   -3: 3.12553977488691 0.210980544038174 1.31067066509084
   0:
   0:
   p 0
   1
   -1: 66
   -3: 0.691713091515871 2.25405307518625 1.18372071153034
   0:
   0:
   p 0
   1
   -1: 67
   -3: -1.62517615679666 1.76714239737207 1.08122144263732
   0:
   0:
   p 0
   1
   -1: 68
   -3: -2.7892412323266 0.520112846738791 1.0384037757918
   0:
   0:
   p 0
   1
   -1: 69
   -3: -3.24683562673053 -0.678947174307207 1.02802708019669
   0:
   0:
   p 0
   1
   -1: 70
   -3: -3.32758617144386 -1.71096546305235 1.03361730676811
   0:
   0:
   p 0
   1
   -1: 71
   -3: -3.14505601167564 -2.61388040597318 1.05013990826956
   0:
   0:
   p 0
   1
   -1: 72
   -3: -2.67166198251255 -3.43472629972986 1.07914997287385
   0:
   0:
   p 0
   1
   -1: 73
   -3: -1.7434465054151 -4.15620363543789 1.12774232252505
   0:
   0:
   p 0
   1
   -1: 74
   -3: -0.0596741212326486 -4.49271562384483 1.20655916154709
   0:
   0:
   p 0
   1
   -1: 75
   -3: 2.31729686140594 -3.42423407068849 1.30380961187647
   0:
   0:
   p 0
   1
   -1: 76
   -3: 3.23113815551203 -0.175634188879364 1.31847561754853
   0:
   0:
   p 0
   1
   -1: 77
   -3: 1.00266538228971 2.16797433246556 1.19867101133041
   0:
   0:
   p 0
   1
   -1: 78
   -3: -1.42508800555629 1.87305478772912 1.08955364255628
   0:
   0:
   p 0
   1
   -1: 79
   -3: -2.69446660095414 0.651733374587824 1.04161791135992
   0:
   0:
   p 0
   1
   -1: 80
   -3: -3.20651379800716 -0.563665321696986 1.02885477172881
   0:
   0:
   p 0
   1
   -1: 81
   -3: -3.31655962934925 -1.61413589028937 1.03325646032358
   0:
   0:
   p 0
   1
   -1: 82
   -3: -3.15559863884596 -2.53049433361297 1.04891200555084
   0:
   0:
   p 0
   1
   -1: 83
   -3: -2.70754215553533 -3.36062531026713 1.07685694426268
   0:
   0:
   p 0
   1
   -1: 84
   -3: -1.82061851473308 -4.09504894333463 1.12371355369491
   0:
   0:
   p 0
   1
   -1: 85
   -3: -0.202293122648957 -4.4794299341833 1.20005197028994
   0:
   0:
   p 0
   1
   -1: 86
   -3: 2.15115622306264 -3.55887967535351 1.29752457658049
   0:
   0:
   p 0
   1
   -1: 87
   -3: 3.26549128525127 -0.427281249328354 1.32201410363122
   0:
   0:
   p 0
   1
   -1: 88
   -3: 1.19820924532339 2.08672615364358 1.20828224544727
   0:
   0:
   p 0
   1
   -1: 89
   -3: -1.28633726023478 1.92821628160604 1.09549245775616
   0:
   0:
   p 0
   1
   -1: 90
   -3: -2.62377011021667 0.730615544114963 1.04419169649399
   0:
   0:
   p 0
   1
   -1: 91
   -3: -3.17146627943775 -0.493839375998225 1.02985064382405
   0:
   0:
   p 0
   1
   -1: 92
   -3: -3.29915496186075 -1.55673330508396 1.03354661112191
   0:
   0:
   p 0
   1
   -1: 93
   -3: -3.1485571865693 -2.48298033901157 1.04881467227645
   0:
   0:
   p 0
   1
   -1: 94
   -3: -2.70967325171003 -3.319987191809 1.07640412919897
   0:
   0:
   p 0
   1
   -1: 95
   -3: -1.83608189914302 -4.06005289117223 1.12271206141988
   0:
   0:
   p 0
   1
   -1: 96
   -3: -0.24078700914547 -4.45750450662637 1.19814357460926
   0:
   0:
   p 0
   1
   -1: 97
   -3: 2.09305798432739 -3.58177560186953 1.29513430269571
   0:
   0:
   p 0
   1
   -1: 98
   -3: 3.25625376579537 -0.505507280757726 1.32222864760736
   0:
   0:
   p 0
   1
   -1: 99
   -3: 1.25408676123794 2.04332079088342 1.21119783519139
   0:
   0:
   p 0
   1
   -1: 100
   -3: -1.23481760258747 1.93096552254688 1.09785637473146
   0:
   0:
   p 0
   1
   -1: 101
   -3: -2.58979280234105 0.745303635998233 1.04564073474468
   0:
   0:
   p 0
   1
   -1: 102
   -3: -3.14653997824137 -0.480867087392741 1.03089295499369
   0:
   0:
   p 0
   1
   -1: 103
   -3: -3.27614998050967 -1.54859079042874 1.03454072541972
   0:
   0:
   p 0
   1
   -1: 104
   -3: -3.12195760698735 -2.4798644812441 1.05001558735912
   0:
   0:
   p 0
   1
   -1: 105
   -3: -2.67321230172287 -3.32037740258917 1.07808106057586
   0:
   0:
   p 0
   1
   -1: 106
   -3: -1.78081848513194 -4.05752253231414 1.1252041393655
   0:
   0:
   p 0
   1
   -1: 107
   -3: -0.159606349629476 -4.42940992566894 1.20155702341872
   0:
   0:
   p 0
   1
   -1: 108
   -3: 2.16466797904535 -3.48242216597201 1.29751729617285
   0:
   0:
   p 0
   1
   -1: 109
   -3: 3.20933445736907 -0.378870468321733 1.3191340149765
   0:
   0:
   p 0
   1
   -1: 110
   -3: 1.14698234706764 2.05520254805232 1.20621948714042
   0:
   0:
   p 0
   1
   -1: 111
   -3: -1.29060249573146 1.87534290992759 1.09577145953903
   0:
   0:
   p 0
   1
   -1: 112
   -3: -2.60186135330936 0.683736891026675 1.04564069536462
   0:
   0:
   p 0
   1
   -1: 113
   -3: -3.13451586713479 -0.53636079864121 1.03195754308757
   0:
   0:
   p 0
   1
   -1: 114
   -3: -3.24630699513379 -1.59997355630151 1.03638804986404
   0:
   0:
   p 0
   1
   -1: 115
   -3: -3.07094591094125 -2.53028856616878 1.05281892513519
   0:
   0:
   p 0
   1
   -1: 116
   -3: -2.58839213601181 -3.36957855161369 1.08240130008337
   0:
   0:
   p 0
   1
   -1: 117
   -3: -1.63730954231049 -4.09108031749097 1.13201168886963
   0:
   0:
   p 0
   1
   -1: 118
   -3: 0.0666136328929626 -4.38403735196019 1.21133043144536
   0:
   0:
   p 0
   1
   -1: 119
   -3: 2.37483188599025 -3.22255310629766 1.30476044827659
   0:
   0:
   p 0
   1
   -1: 120
   -3: 3.09103029660866 -0.0256502527250626 1.31104023518057
   0:
   0:
   p 0
   1
   -1: 121
   -3: 0.853610348517029 2.1091946986422 1.19237485557769
   0:
   0:
   p 0
   1
   -1: 122
   -3: -1.46127663505308 1.7464339141906 1.08901851962939
   0:
   0:
   p 0
   1
   -1: 123
   -3: -2.66181920352819 0.533510621693586 1.0442188897309
   0:
   0:
   p 0
   1
   -1: 124
   -3: -3.13380481522954 -0.671156254778203 1.03321559833636
   0:
   0:
   p 0
   1
   -1: 125
   -3: -3.20463337153068 -1.72077188784781 1.03940654971984
   0:
   0:
   p 0
   1
   -1: 126
   -3: -2.98571976990062 -2.64335539322673 1.05775319811795
   0:
   0:
   p 0
   1
   -1: 127
   -3: -2.43725390777446 -3.47441971750126 1.09023843956839
   0:
   0:
   p 0
   1
   -1: 128
   -3: -1.37456788320731 -4.15752426954991 1.14449548236704
   0:
   0:
   p 0
   1
   -1: 129
   -3: 0.474628131592371 -4.2839570024406 1.22877495680151
   0:
   0:
   p 0
   1
   -1: 130
   -3: 2.69874800972083 -2.72479865652687 1.31515152288644
   0:
   0:
   p 0
   1
   -1: 131
   -3: 2.81310855097059 0.543886746524294 1.29403276595463
   0:
   0:
   p 0
   1
   -1: 132
   -3: 0.360606426117272 2.14933639419967 1.16946945656067
   0:
   0:
   p 0
   1
   -1: 133
   -3: -1.73467769031288 1.51969145813147 1.07837723825238
   0:
   0:
   p 0
   1
   -1: 134
   -3: -2.76021756794704 0.283228915419302 1.04191891032167
   0:
   0:
   p 0
   1
   -1: 135
   -3: -3.13596921121876 -0.89403018994615 1.03513614420946
   0:
   0:
   p 0
   1
   -1: 136
   -3: -3.13992327155052 -1.9195391722093 1.04418617072136
   0:
   0:
   p 0
   1
   -1: 137
   -3: -2.84797071486119 -2.82706228594864 1.06572200116085
   0:
   0:
   p 0
   1
   -1: 138
   -3: -2.18771969696139 -3.63781216755217 1.10306371563318
   0:
   0:
   p 0
   1
   -1: 139
   -3: -0.940658275315712 -4.23590994716519 1.16478695001431
   0:
   0:
   p 0
   1
   -1: 140
   -3: 1.10339172373625 -4.03841546265871 1.25483978201205
   0:
   0:
   p 0
   1
   -1: 141
   -3: 3.0255567268258 -1.87906978455802 1.32292009650043
   0:
   0:
   p 0
   1
   -1: 142
   -3: 2.24470921694183 1.23561961590052 1.26284633171209
   0:
   0:
   p 0
   1
   -1: 143
   -3: -0.310666497335631 2.0803152956842 1.13922837340629
   0:
   0:
   p 0
   1
   -1: 144
   -3: -2.07421641468859 1.16801685091996 1.06578790517982
   0:
   0:
   p 0
   1
   -1: 145
   -3: -2.87453936759886 -0.0746785788787884 1.03985640669116
   0:
   0:
   p 0
   1
   -1: 146
   -3: -3.12347867667392 -1.21036480463635 1.03857564953272
   0:
   0:
   p 0
   1
   -1: 147
   -3: -3.03111492265059 -2.20248949145912 1.05174419723512
   0:
   0:
   p 0
   1
   -1: 148
   -3: -2.62444959366917 -3.08615805916536 1.07827282850798
   0:
   0:
   p 0
   1
   -1: 149
   -3: -1.78299423448557 -3.85051147645184 1.12334114555509
   0:
   0:
   p 0
   1
   -1: 150
   -3: -0.256147191098061 -4.25905021317407 1.19581961039333
   0:
   0:
   p 0
   1
   -1: 151
   -3: 1.94258874201149 -3.45992469221729 1.28750042717854
   0:
   0:
   p 0
   1
   -1: 152
   -3: 3.08153780049324 -0.627298679740617 1.31544556196977
   0:
   0:
   p 0
   1
   -1: 153
   -3: 1.29648405806857 1.82207382378938 1.21501640407061
   0:
   0:
   p 0
   1
   -1: 154
   -3: -1.0797028869651 1.80216379373126 1.10619863319095
   0:
   0:
   p 0
   1
   -1: 155
   -3: -2.42200209461792 0.675204334542963 1.05409166179103
   0:
   0:
   p 0
   1
   -1: 156
   -3: -2.97034627028763 -0.540811277386318 1.03963340556961
   0:
   0:
   p 0
   1
   -1: 157
   -3: -3.06728146864421 -1.62128612191052 1.04487751283957
   0:
   0:
   p 0
   1
   -1: 158
   -3: -2.84086219877628 -2.57215182757953 1.06380080872924
   0:
   0:
   p 0
   1
   -1: 159
   -3: -2.25463180791019 -3.4159954711762 1.09808987507632
   0:
   0:
   p 0
   1
   -1: 160
   -3: -1.12504305198079 -4.06613440133938 1.1550275626731
   0:
   0:
   p 0
   1
   -1: 161
   -3: 0.765206757710325 -4.04453982152096 1.23981236886032
   0:
   0:
   p 0
   1
   -1: 162
   -3: 2.76891786271703 -2.26394345999383 1.31461160509497
   0:
   0:
   p 0
   1
   -1: 163
   -3: 2.4673748721802 0.806126035503928 1.2764031213215
   0:
   0:
   p 0
   1
   -1: 164
   -3: 0.062079009635739 2.00512577302378 1.15703474303641
   0:
   0:
   p 0
   1
   -1: 165
   -3: -1.81689961465542 1.26633601315595 1.07685256532226
   0:
   0:
   p 0
   1
   -1: 166
   -3: -2.71122051950475 0.046617080321438 1.04635151804678
   0:
   0:
   p 0
   1
   -1: 167
   -3: -3.0034780206492 -1.10778033303244 1.04321887872383
   0:
   0:
   p 0
   1
   -1: 168
   -3: -2.92161166416787 -2.12345272528266 1.05609931353975
   0:
   0:
   p 0
   1
   -1: 169
   -3: -2.50207968699366 -3.0229904972376 1.08333798472818
   0:
   0:
   p 0
   1
   -1: 170
   -3: -1.62770044247876 -3.78059515642996 1.12980989401857
   0:
   0:
   p 0
   1
   -1: 171
   -3: -0.0679866306245234 -4.12504842526671 1.20316849284738
   0:
   0:
   p 0
   1
   -1: 172
   -3: 2.05393330107243 -3.18699900334884 1.29026597382247
   0:
   0:
   p 0
   1
   -1: 173
   -3: 2.91617814928428 -0.377680270743188 1.30609055121396
   0:
   0:
   p 0
   1
   -1: 174
   -3: 1.0605299669241 1.78133833539922 1.20463030341264
   0:
   0:
   p 0
   1
   -1: 175
   -3: -1.16409957917296 1.62888333708994 1.10384656773178
   0:
   0:
   p 0
   1
   -1: 176
   -3: -2.39537984501753 0.503892734666867 1.05688575776257
   0:
   0:
   p 0
   1
   -1: 177
   -3: -2.87885868147624 -0.692659544610146 1.0452572368908
   0:
   0:
   p 0
   1
   -1: 178
   -3: -2.91728621021919 -1.76249504497517 1.05308318192093
   0:
   0:
   p 0
   1
   -1: 179
   -3: -2.60939267321745 -2.7065750340771 1.07563858520968
   0:
   0:
   p 0
   1
   -1: 180
   -3: -1.88910655937506 -3.52084958033036 1.11568686774829
   0:
   0:
   p 0
   1
   -1: 181
   -3: -0.556018734157093 -4.03172646288074 1.18044136589191
   0:
   0:
   p 0
   1
   -1: 182
   -3: 1.45246716700682 -3.57157486425411 1.26662515832715
   0:
   0:
   p 0
   1
   -1: 183
   -3: 2.89230542387561 -1.24048432641668 1.31194387146148
   0:
   0:
   p 0
   1
   -1: 184
   -3: 1.7053601291521 1.3656666281727 1.23742158849727
   0:
   0:
   p 0
   1
   -1: 185
   -3: -0.609935995123484 1.76762811258753 1.12820732242822
   0:
   0:
   p 0
   1
   -1: 186
   -3: -2.09354504653166 0.798091760132405 1.06824347551799
   0:
   0:
   p 0
   1
   -1: 187
   -3: -2.7341973548174 -0.405144319967646 1.04937595674834
   0:
   0:
   p 0
   1
   -1: 188
   -3: -2.86327659201915 -1.5107269336218 1.05333186240496
   0:
   0:
   p 0
   1
   -1: 189
   -3: -2.6243017393177 -2.48686327841212 1.07302116316849
   0:
   0:
   p 0
   1
   -1: 190
   -3: -1.98553716153027 -3.33199227702783 1.10966303508214
   0:
   0:
   p 0
   1
   -1: 191
   -3: -0.774510243076989 -3.91097484789089 1.16957612867042
   0:
   0:
   p 0
   1
   -1: 192
   -3: 1.11789865392801 -3.66351467086947 1.25246572096872
   0:
   0:
   p 0
   1
   -1: 193
   -3: 2.74235076648003 -1.66220740403172 1.30865409763612
   0:
   0:
   p 0
   1
   -1: 194
   -3: 1.98294947260156 1.03059548956539 1.25276017052758
   0:
   0:
   p 0
   1
   -1: 195
   -3: -0.273216992219772 1.75896395208834 1.14379018265419
   0:
   0:
   p 0
   1
   -1: 196
   -3: -1.87775554356111 0.923595760463321 1.07712466639386
   0:
   0:
   p 0
   1
   -1: 197
   -3: -2.60785985971468 -0.264336069420655 1.05396882013428
   0:
   0:
   p 0
   1
   -1: 198
   -3: -2.78497092648647 -1.38469403649412 1.0558279451981
   0:
   0:
   p 0
   1
   -1: 199
   -3: -2.57282564586978 -2.37690874159818 1.07442210960708
   0:
   0:
   p 0
   1
   -1: 200
   -3: -1.95549327338673 -3.23186918511472 1.11017255290783
   0:
   0:
   p 0
   1
   -1: 201
   -3: -0.776693762325162 -3.81619542170909 1.16868494417354
   0:
   0:
   p 0
   1
   -1: 202
   -3: 1.05752292704478 -3.59471818653373 1.2492174083526
   0:
   0:
   p 0
   1
   -1: 203
   -3: 2.64584491031028 -1.69131425614156 1.30460401967079
   0:
   0:
   p 0
   1
   -1: 204
   -3: 1.97189697169012 0.918989061699904 1.25319136657583
   0:
   0:
   p 0
   1
   -1: 205
   -3: -0.202150835394747 1.68283663858441 1.14772723190135
   0:
   0:
   p 0
   1
   -1: 206
   -3: -1.79229673083455 0.893328771190787 1.08136005420132
   0:
   0:
   p 0
   1
   -1: 207
   -3: -2.52395775223946 -0.276019912684164 1.05796703029765
   0:
   0:
   p 0
   1
   -1: 208
   -3: -2.69532900804504 -1.39206261615772 1.06004000158228
   0:
   0:
   p 0
   1
   -1: 209
   -3: -2.46388982684912 -2.38201260041881 1.07947859188982
   0:
   0:
   p 0
   1
   -1: 210
   -3: -1.809740817611 -3.22287688089091 1.11674863670118
   0:
   0:
   p 0
   1
   -1: 211
   -3: -0.582472434339308 -3.75153644952558 1.17691547521835
   0:
   0:
   p 0
   1
   -1: 212
   -3: 1.24394728010199 -3.39121384896787 1.25588736178754
   0:
   0:
   p 0
   1
   -1: 213
   -3: 2.61563359217159 -1.37891334425057 1.30076319209438
   0:
   0:
   p 0
   1
   -1: 214
   -3: 1.71850615949642 1.02832686566589 1.2408474197822
   0:
   0:
   p 0
   1
   -1: 215
   -3: -0.38143763568107 1.5620900528242 1.14054751449746
   0:
   0:
   p 0
   1
   -1: 216
   -3: -1.83698483329172 0.72023314807738 1.08084633921659
   0:
   0:
   p 0
   1
   -1: 217
   -3: -2.48237436847535 -0.435021283598299 1.06132575096413
   0:
   0:
   p 0
   1
   -1: 218
   -3: -2.59065190240298 -1.53011171490312 1.06610689062044
   0:
   0:
   p 0
   1
   -1: 219
   -3: -2.28892495448182 -2.49755271712971 1.08853053102109
   0:
   0:
   p 0
   1
   -1: 220
   -3: -1.53504053626912 -3.2911147607977 1.12985255601038
   0:
   0:
   p 0
   1
   -1: 221
   -3: -0.18572168629862 -3.67934601629434 1.19419764966902
   0:
   0:
   p 0
   1
   -1: 222
   -3: 1.62625614973587 -2.99670135936544 1.26974075266667
   0:
   0:
   p 0
   1
   -1: 223
   -3: 2.53919683350973 -0.762055885559598 1.29239761359695
   0:
   0:
   p 0
   1
   -1: 224
   -3: 1.2211508262242 1.24516747650481 1.21650297262339
   0:
   0:
   p 0
   1
   -1: 225
   -3: -0.749942977113576 1.35864818314454 1.125379710307
   0:
   0:
   p 0
   1
   -1: 226
   -3: -1.96996030534468 0.410272909683694 1.07747143405072
   0:
   0:
   p 0
   1
   -1: 227
   -3: -2.4575019962881 -0.728246502159237 1.06510760270239
   0:
   0:
   p 0
   1
   -1: 228
   -3: -2.44846129268669 -1.78596979932031 1.07493533967527
   0:
   0:
   p 0
   1
   -1: 229
   -3: -2.0196457392138 -2.70597983353955 1.10269152687809
   0:
   0:
   p 0
   1
   -1: 230
   -3: -1.09521584778929 -3.39705665118924 1.15073925916183
   0:
   0:
   p 0
   1
   -1: 231
   -3: 0.425491617849274 -3.50550428410991 1.22022384350695
   0:
   0:
   p 0
   1
   -1: 232
   -3: 2.08013900853361 -2.30069220528782 1.2843459799617
   0:
   0:
   p 0
   1
   -1: 233
   -3: 2.22053482202677 0.0565375816987491 1.27149066575086
   0:
   0:
   p 0
   1
   -1: 234
   -3: 0.499363329146054 1.38482915149106 1.18245478501313
   0:
   0:
   p 0
   1
   -1: 235
   -3: -1.2102295783347 1.01606147426023 1.10718995517615
   0:
   0:
   p 0
   1
   -1: 236
   -3: -2.1236718214909 -0.0289916797090507 1.07429516786597
   0:
   0:
   p 0
   1
   -1: 237
   -3: -2.40452455827312 -1.13538421475037 1.0711909834399
   0:
   0:
   p 0
   1
   -1: 238
   -3: -2.2273762601392 -2.13620384624281 1.08819332961099
   0:
   0:
   p 0
   1
   -1: 239
   -3: -1.60540944178988 -2.9692969621653 1.12389132562962
   0:
   0:
   p 0
   1
   -1: 240
   -3: -0.438591032142996 -3.45265724451778 1.18091620008147
   0:
   0:
   p 0
   1
   -1: 241
   -3: 1.21024517606891 -3.0578714276383 1.25168741683186
   0:
   0:
   p 0
   1
   -1: 242
   -3: 2.33368855819588 -1.23716064211473 1.28707430674596
   0:
   0:
   p 0
   1
   -1: 243
   -3: 1.50303247644502 0.818767951711859 1.2328687084937
   0:
   0:
   p 0
   1
   -1: 244
   -3: -0.33706478516019 1.27322858218769 1.14512635074163
   0:
   0:
   p 0
   1
   -1: 245
   -3: -1.64759253996861 0.508962279694678 1.09150555863217
   0:
   0:
   p 0
   1
   -1: 246
   -3: -2.22394650428703 -0.577905172104586 1.07456633322553
   0:
   0:
   p 0
   1
   -1: 247
   -3: -2.26618861839557 -1.62785466559394 1.08193581678898
   0:
   0:
   p 0
   1
   -1: 248
   -3: -1.86596913017956 -2.54157423921052 1.10829991857979
   0:
   0:
   p 0
   1
   -1: 249
   -3: -0.974245883463841 -3.20780240483316 1.15462584466824
   0:
   0:
   p 0
   1
   -1: 250
   -3: 0.459890772166296 -3.27975130796481 1.21991496980451
   0:
   0:
   p 0
   1
   -1: 251
   -3: 1.94375709536704 -2.12748245264891 1.2768814265835
   0:
   0:
   p 0
   1
   -1: 252
   -3: 2.02062888785467 -0.00116725634785 1.26299847080825
   0:
   0:
   p 0
   1
   -1: 253
   -3: 0.459861581249873 1.18456109126241 1.18237892648027
   0:
   0:
   p 0
   1
   -1: 254
   -3: -1.11003573135885 0.84685905310664 1.11331725528887
   0:
   0:
   p 0
   1
   -1: 255
   -3: -1.96079016380123 -0.138925036616233 1.08281265505667
   0:
   0:
   p 0
   1
   -1: 256
   -3: -2.20110750532316 -1.20277862992588 1.08117650680201
   0:
   0:
   p 0
   1
   -1: 257
   -3: -1.97304708988859 -2.16432878940902 1.100114705453
   0:
   0:
   p 0
   1
   -1: 258
   -3: -1.2808497607446 -2.92735905362444 1.13831656098539
   0:
   0:
   p 0
   1
   -1: 259
   -3: -0.0613807745330602 -3.25132756038836 1.19624843615953
   0:
   0:
   p 0
   1
   -1: 260
   -3: 1.45654246948404 -2.59524062867668 1.25893394982986
   0:
   0:
   p 0
   1
   -1: 261
   -3: 2.12688212027418 -0.736107282342897 1.27377781132885
   0:
   0:
   p 0
   1
   -1: 262
   -3: 1.04085740564766 0.878125499253018 1.21143616861889
   0:
   0:
   p 0
   1
   -1: 263
   -3: -0.601522359655993 0.990980275365945 1.13545498874886
   0:
   0:
   p 0
   1
   -1: 264
   -3: -1.66743545643196 0.169996873828985 1.09361160542117
   0:
   0:
   p 0
   1
   -1: 265
   -3: -2.07804727117775 -0.872304488857572 1.08392266372766
   0:
   0:
   p 0
   1
   -1: 266
   -3: -1.98599375730883 -1.85683636928224 1.096833800127
   0:
   0:
   p 0
   1
   -1: 267
   -3: -1.43716524665108 -2.67217285558181 1.12901336814098
   0:
   0:
   p 0
   1
   -1: 268
   -3: -0.385414484904024 -3.13096224384099 1.18063045527392
   0:
   0:
   p 0
   1
   -1: 269
   -3: 1.0552283871375 -2.78634974677918 1.24255158340548
   0:
   0:
   p 0
   1
   -1: 270
   -3: 2.0219723796251 -1.24686887053003 1.27324429482947
   0:
   0:
   p 0
   1
   -1: 271
   -3: 1.37906832883759 0.516536260581464 1.22980213884372
   0:
   0:
   p 0
   1
   -1: 272
   -3: -0.191750895247686 0.990713027361737 1.15426280344458
   0:
   0:
   p 0
   1
   -1: 273
   -3: -1.39084032718081 0.355551840683294 1.10472653915511
   0:
   0:
   p 0
   1
   -1: 274
   -3: -1.93233662797477 -0.638645746096531 1.08857117179789
   0:
   0:
   p 0
   1
   -1: 275
   -3: -1.94325992386484 -1.62548726428421 1.096769755362
   0:
   0:
   p 0
   1
   -1: 276
   -3: -1.49497254465436 -2.46511587837233 1.12459626078262
   0:
   0:
   p 0
   1
   -1: 277
   -3: -0.562693945159113 -2.99197969283581 1.17145069139238
   0:
   0:
   p 0
   1
   -1: 278
   -3: 0.782156618526838 -2.82505370426522 1.2306379595821
   0:
   0:
   p 0
   1
   -1: 279
   -3: 1.85918334888712 -1.53906280166609 1.26834553899793
   0:
   0:
   p 0
   1
   -1: 280
   -3: 1.52608202793718 0.211415409632621 1.23899006109456
   0:
   0:
   p 0
   1
   -1: 281
   -3: 0.0885879176996141 0.911199248781149 1.16778363653284
   0:
   0:
   p 0
   1
   -1: 282
   -3: -1.16459626940352 0.438671024659778 1.11441714731828
   0:
   0:
   p 0
   1
   -1: 283
   -3: -1.78988552028233 -0.495869754281819 1.09387414124217
   0:
   0:
   p 0
   1
   -1: 284
   -3: -1.87025108568994 -1.46926249581676 1.09875422957208
   0:
   0:
   p 0
   1
   -1: 285
   -3: -1.48710498016632 -2.31271374513202 1.12364233457337
   0:
   0:
   p 0
   1
   -1: 286
   -3: -0.633389298423813 -2.8651157370681 1.16718251917519
   0:
   0:
   p 0
   1
   -1: 287
   -3: 0.627843000635957 -2.78475230518946 1.22338486704491
   0:
   0:
   p 0
   1
   -1: 288
   -3: 1.71373456455245 -1.66326689144278 1.26285507678105
   0:
   0:
   p 0
   1
   -1: 289
   -3: 1.54924596281607 0.0074674410355037 1.24173170136302
   0:
   0:
   p 0
   1
   -1: 290
   -3: 0.242265310366893 0.805610525321606 1.17571492537732
   0:
   0:
   p 0
   1
   -1: 291
   -3: -1.00501209616119 0.445168421744003 1.12170516127263
   0:
   0:
   p 0
   1
   -1: 292
   -3: -1.66658286819223 -0.43264258231101 1.09899672103972
   0:
   0:
   p 0
   1
   -1: 293
   -3: -1.78278969038732 -1.38224715976149 1.10200948722107
   0:
   0:
   p 0
   1
   -1: 294
   -3: -1.43383183557022 -2.21331871881526 1.12521845312573
   0:
   0:
   p 0
   1
   -1: 295
   -3: -0.625188107836524 -2.76030674327018 1.16667045999638
   0:
   0:
   p 0
   1
   -1: 296
   -3: 0.570428981989438 -2.701954555948 1.22012519113698
   0:
   0:
   p 0
   1
   -1: 297
   -3: 1.60881902713966 -1.66671176572798 1.25819082509683
   0:
   0:
   p 0
   1
   -1: 298
   -3: 1.49791059410517 -0.0942027667616724 1.24026439559295
   0:
   0:
   p 0
   1
   -1: 299
   -3: 0.28899533727829 0.703658978282561 1.17872463158896
   0:
   0:
   p 0
   1
   -1: 300
   -3: -0.913133389633833 0.397436761516966 1.12634985244738
   0:
   0:
   p 0
   1
   -1: 301
   -3: -1.56871847743312 -0.435624586586238 1.10352968490259
   0:
   0:
   p 0
   1
   -1: 302
   -3: -1.68905272869379 -1.35553942468066 1.10608023614275
   0:
   0:
   p 0
   1
   -1: 303
   -3: -1.34686439608026 -2.16064442212882 1.12873578927077
   0:
   0:
   p 0
   1
   -1: 304
   -3: -0.556321948380079 -2.67668665587801 1.16908540602241
   0:
   0:
   p 0
   1
   -1: 305
   -3: 0.587908340248766 -2.59119441961855 1.21999746995929
   0:
   0:
   p 0
   1
   -1: 306
   -3: 1.54110448407878 -1.58249351731215 1.25447221473618
   0:
   0:
   p 0
   1
   -1: 307
   -3: 1.39849345391086 -0.112277367978835 1.23593486977154
   0:
   0:
   p 0
   1
   -1: 308
   -3: 0.2523282111284 0.614033593795317 1.17782329819046
   0:
   0:
   p 0
   1
   -1: 309
   -3: -0.879830437115916 0.310760678798963 1.12864110627066
   0:
   0:
   p 0
   1
   -1: 310
   -3: -1.4948589173006 -0.491997875293759 1.10742513404686
   0:
   0:
   p 0
   1
   -1: 311
   -3: -1.59127939268996 -1.37875991348637 1.11077011581424
   0:
   0:
   p 0
   1
   -1: 312
   -3: -1.23204419052922 -2.14557731007408 1.13384612371194
   0:
   0:
   p 0
   1
   -1: 313
   -3: -0.438863474341942 -2.60726844849543 1.17382011807927
   0:
   0:
   p 0
   1
   -1: 314
   -3: 0.660140833591343 -2.45477156559701 1.22211803658811
   0:
   0:
   p 0
   1
   -1: 315
   -3: 1.49516711740966 -1.4325351458723 1.25118686138016
   0:
   0:
   p 0
   1
   -1: 316
   -3: 1.26136272030467 -0.0721780023649386 1.22941517344886
   0:
   0:
   p 0
   1
   -1: 317
   -3: 0.153971448616332 0.532051423730549 1.17404258202186
   0:
   0:
   p 0
   1
   -1: 318
   -3: -0.890751641314973 0.193777684210893 1.12916525865681
   0:
   0:
   p 0
   1
   -1: 319
   -3: -1.43842279885913 -0.590543275986142 1.11088651118866
   0:
   0:
   p 0
   1
   -1: 320
   -3: -1.48753160382253 -1.44101007897838 1.11606968086035
   0:
   0:
   p 0
   1
   -1: 321
   -3: -1.09142170000159 -2.15717617748389 1.14035720036373
   0:
   0:
   p 0
   1
   -1: 322
   -3: -0.281581269330619 -2.5413430725576 1.18038350014202
   0:
   0:
   p 0
   1
   -1: 323
   -3: 0.767726363897597 -2.28890904322533 1.22558409241984
   0:
   0:
   p 0
   1
   -1: 324
   -3: 1.45071884021137 -1.23337489940555 1.24755903977463
   0:
   0:
   p 0
   1
   -1: 325
   -3: 1.08930933212085 -0.000722819419126788 1.22104564618581
   0:
   0:
   p 0
   1
   -1: 326
   -3: 0.0130223411984461 0.447016260033228 1.1683429294613
   0:
   0:
   p 0
   1
   -1: 327
   -3: -0.929797088125606 0.0509198861525466 1.1286240129903
   0:
   0:
   p 0
   1
   -1: 328
   -3: -1.39013285315326 -0.721577825176286 1.11425440675127
   0:
   0:
   p 0
   1
   -1: 329
   -3: -1.37338475378602 -1.53127987938963 1.12208224601864
   0:
   0:
   p 0
   1
   -1: 330
   -3: -0.925051204959831 -2.18319067823175 1.14815613296954
   0:
   0:
   p 0
   1
   -1: 331
   -3: -0.0924457795483244 -2.46598157407988 1.18830203378039
   0:
   0:
   p 0
   1
   -1: 332
   -3: 0.890381110456916 -2.08822916370362 1.22943977407956
   0:
   0:
   p 0
   1
   -1: 333
   -3: 1.38692014218875 -1.00123716913772 1.24278285051107
   0:
   0:
   p 0
   1
   -1: 334
   -3: 0.884205176676161 0.0761784147969278 1.21111867867611
   0:
   0:
   p 0
   1
   -1: 335
   -3: -0.153168627249765 0.347591524346607 1.1616111404249
   0:
   0:
   p 0
   1
   -1: 336
   -3: -0.981193898769406 -0.114985629003476 1.12771700393537
   0:
   0:
   p 0
   1
   -1: 337
   -3: -1.33991746496022 -0.876360902761728 1.11791338801116
   0:
   0:
   p 0
   1
   -1: 338
   -3: -1.24340107024283 -1.63845578694754 1.12895620120138
   0:
   0:
   p 0
   1
   -1: 339
   -3: -0.732652644784891 -2.21031250881529 1.15713650331085
   0:
   0:
   p 0
   1
   -1: 340
   -3: 0.119114600876898 -2.36739761920329 1.19703109674947
   0:
   0:
   p 0
   1
   -1: 341
   -3: 1.00602860881934 -1.84964086777871 1.23266809470627
   0:
   0:
   p 0
   1
   -1: 342
   -3: 1.28607883078844 -0.755174204489999 1.23621329724579
   0:
   0:
   p 0
   1
   -1: 343
   -3: 0.651108107447855 0.135412310838879 1.20005079436726
   0:
   0:
   p 0
   1
   -1: 344
   -3: -0.328371200990936 0.225146045967911 1.15466220174508
   0:
   0:
   p 0
   1
   -1: 345
   -3: -1.03066025352589 -0.300848925208108 1.12707238774133
   0:
   0:
   p 0
   1
   -1: 346
   -3: -1.27819644499897 -1.0464337646121 1.12222685756643
   0:
   0:
   p 0
   1
   -1: 347
   -3: -1.09235687423199 -1.75111713446994 1.1368270387889
   0:
   0:
   p 0
   1
   -1: 348
   -3: -0.51523793219217 -2.22439034901364 1.16712712021401
   0:
   0:
   p 0
   1
   -1: 349
   -3: 0.340309072886326 -2.23269561007482 1.20588509370368
   0:
   0:
   p 0
   1
   -1: 350
   -3: 1.09141955793909 -1.57587141674187 1.23424681020737
   0:
   0:
   p 0
   1
   -1: 351
   -3: 1.13724197469963 -0.517636989136814 1.22753335932018
   0:
   0:
   p 0
   1
   -1: 352
   -3: 0.399764179155666 0.158771215825496 1.18843530521134
   0:
   0:
   p 0
   1
   -1: 353
   -3: -0.497583924921984 0.0753797280152969 1.14822030279631
   0:
   0:
   p 0
   1
   -1: 354
   -3: -1.0660251190923 -0.502349644160023 1.12720987078941
   0:
   0:
   p 0
   1
   -1: 355
   -3: -1.19667791269411 -1.22309886164297 1.1274958593067
   0:
   0:
   p 0
   1
   -1: 356
   -3: -0.916310857332777 -1.85728727761443 1.14576671217067
   0:
   0:
   p 0
   1
   -1: 357
   -3: -0.276749627579212 -2.21089761121349 1.17782290145939
   0:
   0:
   p 0
   1
   -1: 358
   -3: 0.553832431182096 -2.05233799277636 1.21400683909525
   0:
   0:
   p 0
   1
   -1: 359
   -3: 1.12473973743819 -1.2780409556592 1.23328436667291
   0:
   0:
   p 0
   1
   -1: 360
   -3: 0.938923261946129 -0.312364622456123 1.21686283490247
   0:
   0:
   p 0
   1
   -1: 361
   -3: 0.143853377366742 0.134771394004308 1.17699393474849
   0:
   0:
   p 0
   1
   -1: 362
   -3: -0.647618584325049 -0.101411437404125 1.14288850744672
   0:
   0:
   p 0
   1
   -1: 363
   -3: -1.07749769058436 -0.713663006283292 1.12852569123372
   0:
   0:
   p 0
   1
   -1: 364
   -3: -1.08886379424697 -1.39706550106599 1.13393302552438
   0:
   0:
   p 0
   1
   -1: 365
   -3: -0.713655528553237 -1.94430017809081 1.15573538222177
   0:
   0:
   p 0
   1
   -1: 366
   -3: -0.0256242854034676 -2.15599606355321 1.18872470225538
   0:
   0:
   p 0
   1
   -1: 367
   -3: 0.738161752641776 -1.82327609161758 1.22040606154021
   0:
   0:
   p 0
   1
   -1: 368
   -3: 1.08988012899504 -0.976104064563239 1.22921338880161
   0:
   0:
   p 0
   1
   -1: 369
   -3: 0.699763649697444 -0.16042583446975 1.20476080023216
   0:
   0:
   p 0
   1
   -1: 370
   -3: -0.101192838476377 0.0594194661435743 1.16647015935055
   0:
   0:
   p 0
   1
   -1: 371
   -3: -0.767703664907675 -0.300989102224308 1.13912505940972
   0:
   0:
   p 0
   1
   -1: 372
   -3: -1.05771139483803 -0.927563681807103 1.13129136673075
   0:
   0:
   p 0
   1
   -1: 373
   -3: -0.950472142280665 -1.55823312532878 1.14164192676164
   0:
   0:
   p 0
   1
   -1: 374
   -3: -0.486265497322882 -1.99898559579152 1.16653215444964
   0:
   0:
   p 0
   1
   -1: 375
   -3: 0.224073322904309 -2.04850803262571 1.19910601588971
   0:
   0:
   p 0
   1
   -1: 376
   -3: 0.870025104936277 -1.55200288649515 1.2240928186665
   0:
   0:
   p 0
   1
   -1: 377
   -3: 0.980904682576069 -0.696179070154062 1.22197060738851
   0:
   0:
   p 0
   1
   -1: 378
   -3: 0.436527905474018 -0.0761404471952792 1.19210589851877
   0:
   0:
   p 0
   1
   -1: 379
   -3: -0.320694724922041 -0.0643950704046902 1.15751751629936
   0:
   0:
   p 0
   1
   -1: 380
   -3: -0.849800129592212 -0.516249209438146 1.13723683557835
   0:
   0:
   p 0
   1
   -1: 381
   -3: -1.00167586962624 -1.13564217298717 1.13565796416163
   0:
   0:
   p 0
   1
   -1: 382
   -3: -0.779959990838787 -1.69562717411894 1.15059365185341
   0:
   0:
   p 0
   1
   -1: 383
   -3: -0.240721193799142 -2.00844695895978 1.17774800789867
   0:
   0:
   p 0
   1
   -1: 384
   -3: 0.452641070303793 -1.88284793693512 1.20803726864324
   0:
   0:
   p 0
   1
   -1: 385
   -3: 0.929155111046928 -1.25603214459261 1.22429933898402
   0:
   0:
   p 0
   1
   -1: 386
   -3: 0.804513884140145 -0.465038607970354 1.21206771448588
   0:
   0:
   p 0
   1
   -1: 387
   -3: 0.170094223368539 -0.0646750716616525 1.17989584183824
   0:
   0:
   p 0
   1
   -1: 388
   -3: -0.502622369943996 -0.228565316732071 1.15062378565157
   0:
   0:
   p 0
   1
   -1: 389
   -3: -0.888580971327918 -0.738291086678954 1.13738887264667
   0:
   0:
   p 0
   1
   -1: 390
   -3: -0.906790045961727 -1.32849401327622 1.14165774021051
   0:
   0:
   p 0
   1
   -1: 391
   -3: -0.579263130498025 -1.79760331919609 1.16059634192632
   0:
   0:
   p 0
   1
   -1: 392
   -3: 0.0106750801245266 -1.96172395656853 1.18873568514454
   0:
   0:
   p 0
   1
   -1: 393
   -3: 0.636727040053012 -1.66234438513417 1.21450096581035
   0:
   0:
   p 0
   1
   -1: 394
   -3: 0.90411761589407 -0.962164254301204 1.22072554299942
   0:
   0:
   p 0
   1
   -1: 395
   -3: 0.578883987945867 -0.303717029275437 1.20049355160764
   0:
   0:
   p 0
   1
   -1: 396
   -3: -0.0789665074838127 -0.122143200117314 1.16904463638443
   0:
   0:
   p 0
   1
   -1: 397
   -3: -0.638489277301942 -0.421806296005922 1.14608498205942
   0:
   0:
   p 0
   1
   -1: 398
   -3: -0.881220649527429 -0.957219147511804 1.13962105148095
   0:
   0:
   p 0
   1
   -1: 399
   -3: -0.773059022600718 -1.49588686658379 1.14919672426307
   0:
   0:
   p 0
   1
   -1: 400
   -3: -0.354730576605711 -1.8525457089345 1.17126056611107
   0:
   0:
   p 0
   1
   -1: 401
   -3: 0.249723282898609 -1.8524520350204 1.19862500897392
   0:
   0:
   p 0
   1
   -1: 402
   -3: 0.753776885680785 -1.40153731258812 1.21760670990769
   0:
   0:
   p 0
   1
   -1: 403
   -3: 0.796706690725501 -0.701048601810593 1.2136946268479
   0:
   0:
   p 0
   1
   -1: 404
   -3: 0.329125797137579 -0.222920307334483 1.18847563591622
   0:
   0:
   p 0
   1
   -1: 405
   -3: -0.293692122167466 -0.237734327849441 1.16024521682696
   0:
   0:
   p 0
   1
   -1: 406
   -3: -0.723369453148583 -0.631434374973221 1.14401865514944
   0:
   0:
   p 0
   1
   -1: 407
   -3: -0.82721226305417 -1.16261661754431 1.14386130026343
   0:
   0:
   p 0
   1
   -1: 408
   -3: -0.603598544507269 -1.62704568434341 1.15803562619644
   0:
   0:
   p 0
   1
   -1: 409
   -3: -0.11799451444262 -1.85033268483652 1.18197425201135
   0:
   0:
   p 0
   1
   -1: 410
   -3: 0.453862844159445 -1.68210828944996 1.20641825384265
   0:
   0:
   p 0
   1
   -1: 411
   -3: 0.788158122992594 -1.12558600555163 1.21685783045857
   0:
   0:
   p 0
   1
   -1: 412
   -3: 0.622440417467147 -0.499693520952678 1.20412076177884
   0:
   0:
   p 0
   1
   -1: 413
   -3: 0.0814060441249112 -0.221916113360725 1.17720381815067
   0:
   0:
   p 0
   1
   -1: 414
   -3: -0.462248502109647 -0.39664912094587 1.15392048039266
   0:
   0:
   p 0
   1
   -1: 415
   -3: -0.755445961093636 -0.84455839092188 1.14439494532644
   0:
   0:
   p 0
   1
   -1: 416
   -3: -0.72839959183755 -1.34379601012314 1.14992748230658
   0:
   0:
   p 0
   1
   -1: 417
   -3: -0.405385739189551 -1.71129984442359 1.16776301750426
   0:
   0:
   p 0
   1
   -1: 418
   -3: 0.113797703672995 -1.7847091116921 1.19191338692245
   0:
   0:
   p 0
   1
   -1: 419
   -3: 0.600042167366525 -1.46262592247989 1.21118271046781
   0:
   0:
   p 0
   1
   -1: 420
   -3: 0.736620528963865 -0.865730063292163 1.21235946407308
   0:
   0:
   p 0
   1
   -1: 421
   -3: 0.406608808437555 -0.375094370457165 1.19328528237106
   0:
   0:
   p 0
   1
   -1: 422
   -3: -0.141878103130663 -0.290627525709909 1.16762342689419
   0:
   0:
   p 0
   1
   -1: 423
   -3: -0.577925111909043 -0.582710412785776 1.15024324376203
   0:
   0:
   p 0
   1
   -1: 424
   -3: -0.735514244966532 -1.04867644187442 1.14706549556593
   0:
   0:
   p 0
   1
   -1: 425
   -3: -0.589317669143 -1.49004411246951 1.15751549061716
   0:
   0:
   p 0
   1
   -1: 426
   -3: -0.190007851393761 -1.73936733067471 1.17777406363558
   0:
   0:
   p 0
   1
   -1: 427
   -3: 0.319197244754021 -1.65626402913475 1.20012125565742
   0:
   0:
   p 0
   1
   -1: 428
   -3: 0.670478064055886 -1.21658340070727 1.21230721996175
   0:
   0:
   p 0
   1
   -1: 429
   -3: 0.610262731891376 -0.651874911360669 1.20485109188419
   0:
   0:
   p 0
   1
   -1: 430
   -3: 0.177805726916329 -0.331568708416016 1.18252429419189
   0:
   0:
   p 0
   1
   -1: 431
   -3: -0.324587753932604 -0.413288872410341 1.16034665629262
   0:
   0:
   p 0
   1
   -1: 432
   -3: -0.6383182578069 -0.780086372036529 1.14918797291544
   0:
   0:
   p 0
   1
   -1: 433
   -3: -0.666729974241161 -1.23188351044333 1.15177828923569
   0:
   0:
   p 0
   1
   -1: 434
   -3: -0.417794937134091 -1.59114110568939 1.16617799578289
   0:
   0:
   p 0
   1
   -1: 435
   -3: 0.0261067946004097 -1.70542278419112 1.1872787341099
   0:
   0:
   p 0
   1
   -1: 436
   -3: 0.475748152939641 -1.47499641379228 1.20567561229274
   0:
   0:
   p 0
   1
   -1: 437
   -3: 0.658327008884047 -0.973671114285301 1.20972639527417
   0:
   0:
   p 0
   1
   -1: 438
   -3: 0.431731751275246 -0.505373774097142 1.19552799728839
   0:
   0:
   p 0
   1
   -1: 439
   -3: -0.0380942430474161 -0.36214313476541 1.17296359992654
   0:
   0:
   p 0
   1
   -1: 440
   -3: -0.457134103990879 -0.57195661216281 1.15566485878806
   0:
   0:
   p 0
   1
   -1: 441
   -3: -0.644385068582664 -0.97411596955551 1.15058220741636
   0:
   0:
   p 0
   1
   -1: 442
   -3: -0.554716325028886 -1.3829886534041 1.15817548771763
   0:
   0:
   p 0
   1
   -1: 443
   -3: -0.22557807491043 -1.63842528439235 1.17530677528502
   0:
   0:
   p 0
   1
   -1: 444
   -3: 0.222689287371084 -1.60971171239937 1.19536870939764
   0:
   0:
   p 0
   1
   -1: 445
   -3: 0.565117408624964 -1.26087736735535 1.2079204461222
   0:
   0:
   p 0
   1
   -1: 446
   -3: 0.570507654352596 -0.763998253388467 1.20399548599602
   0:
   0:
   p 0
   1
   -1: 447
   -3: 0.22906386049753 -0.435094700226786 1.1857346132123
   0:
   0:
   p 0
   1
   -1: 448
   -3: -0.221527083305656 -0.452344798749112 1.16538111941541
   0:
   0:
   p 0
   1
   -1: 449
   -3: -0.535497660654369 -0.748941077427971 1.15361264273236
   0:
   0:
   p 0
   1
   -1: 450
   -3: -0.599791777677811 -1.15153940012528 1.15414007632741
   0:
   0:
   p 0
   1
   -1: 451
   -3: -0.407969929518127 -1.49185527157339 1.16577960197126
   0:
   0:
   p 0
   1
   -1: 452
   -3: -0.028515874264798 -1.62653577414643 1.18414018977347
   0:
   0:
   p 0
   1
   -1: 453
   -3: 0.378435245176915 -1.4608590018916 1.20116102547896
   0:
   0:
   p 0
   1
   -1: 454
   -3: 0.578445150135792 -1.0411190147343 1.20668183878145
   0:
   0:
   p 0
   1
   -1: 455
   -3: 0.426019305040987 -0.61088860653984 1.19616121815191
   0:
   0:
   p 0
   1
   -1: 456
   -3: 0.0291793721265049 -0.437788551160139 1.17667159073075
   0:
   0:
   p 0
   1
   -1: 457
   -3: -0.360167324909871 -0.584293034888141 1.1601940506258
   0:
   0:
   p 0
   1
   -1: 458
   -3: -0.559925706608618 -0.928047918814255 1.15403865243628
   0:
   0:
   p 0
   1
   -1: 459
   -3: -0.510701388061676 -1.30052701072361 1.159474166605
   0:
   0:
   p 0
   1
   -1: 460
   -3: -0.238322031131117 -1.55022619833814 1.17398110058584
   0:
   0:
   p 0
   1
   -1: 461
   -3: 0.154313720137982 -1.55562365417632 1.19182108781794
   0:
   0:
   p 0
   1
   -1: 462
   -3: 0.475457713698594 -1.27651270922038 1.20400068837069
   0:
   0:
   p 0
   1
   -1: 463
   -3: 0.519449359991622 -0.844392511553692 1.20236141790529
   0:
   0:
   p 0
   1
   -1: 464
   -3: 0.250587634725566 -0.526279677516854 1.18748670547569
   0:
   0:
   p 0
   1
   -1: 465
   -3: -0.146523341552421 -0.501459068263092 1.16921892109631
   0:
   0:
   p 0
   1
   -1: 466
   -3: -0.448120896917769 -0.739760872561597 1.15751925587581
   0:
   0:
   p 0
   1
   -1: 467
   -3: -0.533904743247767 -1.09498524348306 1.15665769168206
   0:
   0:
   p 0
   1
   -1: 468
   -3: -0.385922936968544 -1.41086777195152 1.1660921536665
   0:
   0:
   p 0
   1
   -1: 469
   -3: -0.0610285273200314 -1.5531406952374 1.18204726988953
   0:
   0:
   p 0
   1
   -1: 470
   -3: 0.303015477863224 -1.43330624663689 1.19752023165688
   0:
   0:
   p 0
   1
   -1: 471
   -3: 0.504069657161937 -1.08116810960097 1.20365554723093
   0:
   0:
   p 0
   1
   -1: 472
   -3: 0.403564511867279 -0.694154600243526 1.19584707741155
   0:
   0:
   p 0
   1
   -1: 473
   -3: 0.0703295094650244 -0.510178209348698 1.17916042628661
   0:
   0:
   p 0
   1
   -1: 474
   -3: -0.283799853328887 -0.609556216135512 1.16389185507149
   0:
   0:
   p 0
   1
   -1: 475
   -3: -0.484508893106403 -0.901890727477012 1.15725254599556
   0:
   0:
   p 0
   1
   -1: 476
   -3: -0.463619163178958 -1.23741588447153 1.16107785170804
   0:
   0:
   p 0
   1
   -1: 477
   -3: -0.237166226741857 -1.47457952157628 1.1733919010617
   0:
   0:
   p 0
   1
   -1: 478
   -3: 0.106040857344722 -1.50074345481419 1.18917398120526
   0:
   0:
   p 0
   1
   -1: 479
   -3: 0.400697747795018 -1.27522481215461 1.20061034242354
   0:
   0:
   p 0
   1
   -1: 480
   -3: 0.465794259663441 -0.901255330606569 1.20041172178
   0:
   0:
   p 0
   1
   -1: 481
   -3: 0.253509652356968 -0.603922695611555 1.18827819584697
   0:
   0:
   p 0
   1
   -1: 482
   -3: -0.0930082342660421 -0.553338290639933 1.17209900008181
   0:
   0:
   p 0
   1
   -1: 483
   -3: -0.375153088191395 -0.744394762013751 1.16088539581055
   0:
   0:
   p 0
   1
   -1: 484
   -3: -0.472205883046761 -1.05588332114165 1.15913355500625
   0:
   0:
   p 0
   1
   -1: 485
   -3: -0.357824768501647 -1.34507110866216 1.16680909192327
   0:
   0:
   p 0
   1
   -1: 486
   -3: -0.0790014025724314 -1.48702897059324 1.18067362874427
   0:
   0:
   p 0
   1
   -1: 487
   -3: 0.244504608583925 -1.39985982360399 1.1945923213313
   0:
   0:
   p 0
   1
   -1: 488
   -3: 0.437616113171245 -1.10323049004466 1.20083544294488
   0:
   0:
   p 0
   1
   -1: 489
   -3: 0.373010238664582 -0.759215568184362 1.19501201546287
   0:
   0:
   p 0
   1
   -1: 490
   -3: 0.0935141084684694 -0.576107652491781 1.18077580571811
   0:
   0:
   p 0
   1
   -1: 491
   -3: -0.224226287318279 -0.641175306883462 1.16687657864673
   0:
   0:
   p 0
   1
   -1: 492
   -3: -0.41853523845194 -0.889252451238161 1.16015077177659
   0:
   0:
   p 0
   1
   -1: 493
   -3: -0.417039305696098 -1.18917471897726 1.16278563660609
   0:
   0:
   p 0
   1
   -1: 494
   -3: -0.22787939052456 -1.41020222469454 1.17326712263949
   0:
   0:
   p 0
   1
   -1: 495
   -3: 0.0719349860200383 -1.44836985236459 1.1871878486448
   0:
   0:
   p 0
   1
   -1: 496
   -3: 0.338734404620534 -1.26439073997211 1.19771676354029
   0:
   0:
   p 0
   1
   -1: 497
   -3: 0.413893492227148 -0.941222682261933 1.19839892475223
   0:
   0:
   p 0
   1
   -1: 498
   -3: 0.245361355233368 -0.669008063692817 1.18846031503602
   0:
   0:
   p 0
   1
   -1: 499
   -3: -0.0553998852600108 -0.60397685150439 1.17424273354201
   0:
   0:
   p 0
   1
   -1: 500
   -3: -0.314723623640924 -0.757241609679264 1.16374884019745
   0:
   0:
   p 0
   1
   -1: 501
   -3: -0.41602304527203 -1.02935279819627 1.16146523548618
   0:
   0:
   p 0
   1
   -1: 502
   -3: -0.327417555617094 -1.29155627276024 1.16773560853157
   0:
   0:
   p 0
   1
   -1: 503
   -3: -0.0875554805677326 -1.42845272760744 1.17979008996981
   0:
   0:
   p 0
   1
   -1: 504
   -3: 0.198797751763842 -1.36475809588882 1.19222821618338
   0:
   0:
   p 0
   1
   -1: 505
   -3: 0.379380020861797 -1.11373391738887 1.19828892209058
   0:
   0:
   p 0
   1
   -1: 506
   -3: 0.339437174791158 -0.810014304583812 1.193919658115
   0:
   0:
   p 0
   1
   -1: 507
   -3: 0.10470049934419 -0.634609270114727 1.1817818489128
   0:
   0:
   p 0
   1
   -1: 508
   -3: -0.177903880897395 -0.675083560434987 1.16927575673597
   0:
   0:
   p 0
   1
   -1: 509
   -3: -0.361458202752111 -0.885543492201482 1.16271906623619
   0:
   0:
   p 0
   1
   -1: 510
   -3: -0.372863870184354 -1.15221849157042 1.1644802151983
   0:
   0:
   p 0
   1
   -1: 511
   -3: -0.214149628736346 -1.35553050442866 1.17342634659733
   0:
   0:
   p 0
   1
   -1: 512
   -3: 0.0477624031687881 -1.39997488360174 1.18568421555846
   0:
   0:
   p 0
   1
   -1: 513
   -3: 0.287322158328306 -1.24856482763802 1.19525719180074
   0:
   0:
   p 0
   1
   -1: 514
   -3: 0.365724736859379 -0.969247275603087 1.1964541160394
   0:
   0:
   p 0
   1
   -1: 515
   -3: 0.231044944740188 -0.723253991632935 1.18827051113002
   0:
   0:
   p 0
   1
   -1: 516
   -3: -0.0293248874465486 -0.651363886911414 1.17583292745228
   0:
   0:
   p 0
   1
   -1: 517
   -3: -0.264812123520638 -0.774572066458062 1.16617023721307
   0:
   0:
   p 0
   1
   -1: 518
   -3: -0.365696452465088 -1.01176116955599 1.16360614448219
   0:
   0:
   p 0
   1
   -1: 519
   -3: -0.296918887677612 -1.2478543766376 1.16874984964512
   0:
   0:
   p 0
   1
   -1: 520
   -3: -0.090115384376585 -1.37699081435171 1.17923824518022
   0:
   0:
   p 0
   1
   -1: 521
   -3: 0.162739276682698 -1.33032746523826 1.19030538287186
   0:
   0:
   p 0
   1
   -1: 522
   -3: 0.32879059081611 -1.11695841579073 1.19602631732353
   0:
   0:
   p 0
   1
   -1: 523
   -3: 0.305724886501334 -0.849855062842663 1.19272837256823
   0:
   0:
   p 0
   1
   -1: 524
   -3: 0.108080687994098 -0.685808680549307 1.18237070163492
   0:
   0:
   p 0
   1
   -1: 525
   -3: -0.141854755789386 -0.708867466453005 1.17120505803991
   0:
   0:
   p 0
   1
   -1: 526
   -3: -0.312349099917616 -0.887550556602742 1.16497246946565
   0:
   0:
   p 0
   1
   -1: 527
   -3: -0.332008484097921 -1.12378084419055 1.1660962414341
   0:
   0:
   p 0
   1
   -1: 528
   -3: -0.198307111212437 -1.3090600309628 1.17375111271648
   0:
   0:
   p 0
   1
   -1: 529
   -3: 0.0305542579651653 -1.35607242093968 1.18453344136612
   0:
   0:
   p 0
   1
   -1: 530
   -3: 0.244476190801081 -1.23051985357407 1.19316560461767
   0:
   0:
   p 0
   1
   -1: 531
   -3: 0.322018504781697 -0.988884259826522 1.19464029744412
   0:
   0:
   p 0
   1
   -1: 532
   -3: 0.213669252669588 -0.768451139353485 1.18786517130485
   0:
   0:
   p 0
   1
   -1: 533
   -3: -0.0115065977067576 -0.694640793235266 1.17701190538846
   0:
   0:
   p 0
   1
   -1: 534
   -3: -0.223557174334707 -0.793967364638862 1.16821412386585
   0:
   0:
   p 0
   1
   -1: 535
   -3: -0.321056518187102 -1.00046307882256 1.16554144961998
   0:
   0:
   p 0
   1
   -1: 536
   -3: -0.267594834844908 -1.21196720347181 1.16977721639859
   0:
   0:
   p 0
   1
   -1: 537
   -3: -0.0889535738357559 -1.33196807250555 1.17890954851684
   0:
   0:
   p 0
   1
   -1: 538
   -3: 0.133976811372106 -1.29778486553589 1.188728057893
   0:
   0:
   p 0
   1
   -1: 539
   -3: 0.284992536299806 -1.11571488777889 1.19403278671922
   0:
   0:
   p 0
   1
   -1: 540
   -3: 0.273432312769139 -0.881329230458899 1.19153065695229
   0:
   0:
   p 0
   1
   -1: 541
   -3: 0.106528063823725 -0.730303553547525 1.18267828518933
   0:
   0:
   p 0
   1
   -1: 542
   -3: -0.113705255529771 -0.74116721109096 1.17276141138778
   0:
   0:
   p 0
   1
   -1: 543
   -3: -0.270188616083654 -0.893065718546044 1.16693875790111
   0:
   0:
   p 0
   1
   -1: 544
   -3: -0.29481610909193 -1.10177079486878 1.16760025537447
   0:
   0:
   p 0
   1
   -1: 545
   -3: -0.181800084565726 -1.2694679926951 1.17416446440381
   0:
   0:
   p 0
   1
   -1: 546
   -3: 0.0182445959297 -1.31668377438674 1.18364240930236
   0:
   0:
   p 0
   1
   -1: 547
   -3: 0.208565346451331 -1.21191537770169 1.19138250726958
   0:
   0:
   p 0
   1
   -1: 548
   -3: 0.282872601999102 -1.00263716073333 1.19298303862773
   0:
   0:
   p 0
   1
   -1: 549
   -3: 0.195162273249879 -0.806204044173333 1.18734541568898
   0:
   0:
   p 0
   1
   -1: 550
   -3: 0.000447583951295013 -0.733586436753256 1.1778869521482
   0:
   0:
   p 0
   1
   -1: 551
   -3: -0.189364906346703 -0.813899421431527 1.16994036498915
   0:
   0:
   p 0
   1
   -1: 552
   -3: -0.281693744406527 -0.993558989364453 1.16727366034012
   0:
   0:
   p 0
   1
   -1: 553
   -3: -0.240121416676787 -1.18231606774784 1.17077351340967
   0:
   0:
   p 0
   1
   -1: 554
   -3: -0.0855674830432872 -1.29265243858728 1.17873000048931
   0:
   0:
   p 0
   1
   -1: 555
   -3: 0.110778788885542 -1.26770510268317 1.1874230088153
   0:
   0:
   p 0
   1
   -1: 556
   -3: 0.247100142529329 -1.11183265364769 1.19228384306303
   0:
   0:
   p 0
   1
   -1: 557
   -3: 0.243339748916467 -0.906405840292278 1.19037849085618
   0:
   0:
   p 0
   1
   -1: 558
   -3: 0.10198019594828 -0.76884718868934 1.1827991645059
   0:
   0:
   p 0
   1
   -1: 559
   -3: -0.0916175976925554 -0.771277847253836 1.17402277353403
   0:
   0:
   p 0
   1
   -1: 560
   -3: -0.234004377299021 -0.900595330399528 1.16864965458439
   0:
   0:
   p 0
   1
   -1: 561
   -3: -0.26130598192464 -1.08462541691058 1.16897806372415
   0:
   0:
   p 0
   1
   -1: 562
   -3: -0.165506206054328 -1.235638094056 1.17461707874976
   0:
   0:
   p 0
   1
   -1: 563
   -3: 0.00939922056809486 -1.28158755964392 1.18294444418067
   0:
   0:
   p 0
   1
   -1: 564
   -3: 0.178290035676988 -1.1937181486963 1.18985748596755
   0:
   0:
   p 0
   1
   -1: 565
   -3: 0.248079887662284 -1.01225378831798 1.1914877608421
   0:
   0:
   p 0
   1
   -1: 566
   -3: 0.17668935380463 -0.837860046292135 1.18677553846186
   0:
   0:
   p 0
   1
   -1: 567
   -3: 0.00825911073865941 -0.768315084368988 1.17853752890906
   0:
   0:
   p 0
   1
   -1: 568
   -3: -0.160921211241668 -0.833433489268509 1.17140106723674
   0:
   0:
   p 0
   1
   -1: 569
   -3: -0.247106412616622 -0.989697353556342 1.16881417651299
   0:
   0:
   p 0
   1
   -1: 570
   -3: -0.214812236968036 -1.15766755837743 1.17171397708424
   0:
   0:
   p 0
   1
   -1: 571
   -3: -0.0809360789273071 -1.25834235750428 1.17864931292584
   0:
   0:
   p 0
   1
   -1: 572
   -3: 0.0918736328147322 -1.24029398787388 1.18633460030343
   0:
   0:
   p 0
   1
   -1: 573
   -3: 0.214297335033806 -1.10649256517513 1.19075266977134
   0:
   0:
   p 0
   1
   -1: 574
   -3: 0.215774894352374 -0.926560367568604 1.18929919671305
   0:
   0:
   p 0
   1
   -1: 575
   -3: 0.0957271073055594 -0.802198253330666 1.18279845010684
   0:
   0:
   p 0
   1
   -1: 576
   -3: -0.0741906291789255 -0.798892747503266 1.17505050761529
   0:
   0:
   p 0
   1
   -1: 577
   -3: -0.202926337237024 -0.909144072988761 1.17013644188348
   0:
   0:
   p 0
   1
   -1: 578
   -3: -0.231322045361121 -1.07118204090511 1.17022688742441
   0:
   0:
   p 0
   1
   -1: 579
   -3: -0.149935701200442 -1.20664590642409 1.17507793340659
   0:
   0:
   p 0
   1
   -1: 580
   -3: 0.00302144942614114 -1.25045361628333 1.18239169974031
   0:
   0:
   p 0
   1
   -1: 581
   -3: 0.152626279732308 -1.17646505197446 1.18854890493833
   0:
   0:
   p 0
   1
   -1: 582
   -3: 0.217300226200046 -1.01895130179858 1.19014940663934
   0:
   0:
   p 0
   1
   -1: 583
   -3: 0.158928966968126 -0.864516883940505 1.18619562120919
   0:
   0:
   p 0
   1
   -1: 584
   -3: 0.0131565266524891 -0.799104284973585 1.1790219797866
   0:
   0:
   p 0
   1
   -1: 585
   -3: -0.137163513565901 -0.852024306793142 1.17264013468711
   0:
   0:
   p 0
   1
   -1: 586
   -3: -0.216778117969507 -0.987922252714072 1.17017843729917
   0:
   0:
   p 0
   1
   -1: 587
   -3: -0.191761635328136 -1.13706092300779 1.17258614133539
   0:
   0:
   p 0
   1
   -1: 588
   -3: -0.0756927740058578 -1.22840083903759 1.17863338674923
   0:
   0:
   p 0
   1
   -1: 589
   -3: 0.0763236693983608 -1.21554884850079 1.18542048841175
   0:
   0:
   p 0
   1
   -1: 590
   -3: 0.185868297553544 -1.10044939161493 1.18941335452292
   0:
   0:
   p 0
   1
   -1: 591
   -3: 0.190806947285783 -0.942894364148096 1.18830523470246
   0:
   0:
   p 0
   1
   -1: 592
   -3: 0.0886171493108108 -0.831056656908365 1.1827206508321
   0:
   0:
   p 0
   1
   -1: 593
   -3: -0.0603633996159312 -0.823941960930029 1.17589243494187
   0:
   0:
   p 0
   1
   -1: 594
   -3: -0.176200851965737 -0.918060058230011 1.171428000602
   0:
   0:
   p 0
   1
   -1: 595
   -3: -0.204620518711136 -1.06057596200759 1.17135048038903
   0:
   0:
   p 0
   1
   -1: 596
   -3: -0.13536374699021 -1.18173119115561 1.17552807457583
   0:
   0:
   p 0
   1
   -1: 597
   -3: -0.00158381752444067 -1.22291418807106 1.18194963247215
   0:
   0:
   p 0
   1
   -1: 598
   -3: 0.130767550449114 -1.16042756815059 1.1874226751734
   0:
   0:
   p 0
   1
   -1: 599
   -3: 0.19014910311749 -1.02357839273708 1.1889577868084
   0:
   0:
   p 0
   1
   -1: 600
   -3: 0.142251484857499 -0.887057583009358 1.1856299480904
   0:
   0:
   p 0
   1
   -1: 601
   -3: 0.0160130711179597 -0.826299247282449 1.17938301401793
   0:
   0:
   p 0
   1
   -1: 602
   -3: -0.11724010094358 -0.869379028931218 1.17369396939468
   0:
   0:
   p 0
   1
   -1: 603
   -3: -0.190216031232274 -0.987560287753257 1.17138320698123
   0:
   0:
   p 0
   1
   -1: 604
   -3: -0.170934575076348 -1.11974603575903 1.17338521943747
   0:
   0:
   p 0
   1
   -1: 605
   -3: -0.0702414024341403 -1.20226438422895 1.17865914301386
   0:
   0:
   p 0
   1
   -1: 606
   -3: 0.063431477340925 -1.1933533051762 1.18464819818619
   0:
   0:
   p 0
   1
   -1: 607
   -3: 0.161198635511779 -1.09417881420022 1.18824219511931
   0:
   0:
   p 0
   1
   -1: 608
   -3: 0.168361777302026 -0.956232434128158 1.18740023361317
   0:
   0:
   p 0
   1
   -1: 609
   -3: 0.0812000510130234 -0.856041895832967 1.18259600818243
   0:
   0:
   p 0
   1
   -1: 610
   -3: -0.049333575209069 -0.846491594880432 1.17658571518347
   0:
   0:
   p 0
   1
   -1: 611
   -3: -0.153185815238136 -0.926925876438478 1.17255009993385
   0:
   0:
   p 0
   1
   -1: 612
   -3: -0.180921013626551 -1.05216204126581 1.17235613375773
   0:
   0:
   p 0
   1
   -1: 613
   -3: -0.121916834450038 -1.16026886687347 1.17595644619439
   0:
   0:
   p 0
   1
   -1: 614
   -3: -0.00490412428094417 -1.19860115726631 1.18159307447993
   0:
   0:
   p 0
   1
   -1: 615
   -3: 0.112074933680879 -1.14571500302044 1.18645089115973
   0:
   0:
   p 0
   1
   -1: 616
   -3: 0.166242087842439 -1.02672910334689 1.18790056317967
   0:
   0:
   p 0
   1
   -1: 617
   -3: 0.126834247980558 -0.906190242709168 1.18509256011685
   0:
   0:
   p 0
   1
   -1: 618
   -3: 0.0174485204385591 -0.850261135448138 1.17965192138721
   0:
   0:
   p 0
   1
   -1: 619
   -3: -0.100469727604842 -0.88536604029664 1.17459255010538
   0:
   0:
   p 0
   1
   -1: 620
   -3: -0.166967809828195 -0.988138411334327 1.1724450999036
   0:
   0:
   p 0
   1
   -1: 621
   -3: -0.152223046020074 -1.10513374013887 1.17411111567695
   0:
   0:
   p 0
   1
   -1: 622
   -3: -0.0648339027863798 -1.17944079729138 1.17871098871241
   0:
   0:
   p 0
   1
   -1: 623
   -3: 0.052672200451608 -1.17353343632079 1.18399255127715
   0:
   0:
   p 0
   1
   -1: 624
   -3: 0.139765499930869 -1.08797422598599 1.18721807427253
   0:
   0:
   p 0
   1
   -1: 625
   -3: 0.148290066309881 -0.967196116423779 1.18658269850921
   0:
   0:
   p 0
   1
   -1: 626
   -3: 0.0738248229720687 -0.877691195835046 1.18244494134414
   0:
   0:
   p 0
   1
   -1: 627
   -3: -0.0404928370754933 -0.866681813195054 1.17715927720837
   0:
   0:
   p 0
   1
   -1: 628
   -3: -0.133338268104702 -0.935482954281501 1.17352532439246
   0:
   0:
   p 0
   1
   -1: 629
   -3: -0.159935734183683 -1.04545619132716 1.17325284293177
   0:
   0:
   p 0
   1
   -1: 630
   -3: -0.109628976896134 -1.1417430971094 1.17635712153247
   0:
   0:
   p 0
   1
   -1: 631
   -3: -0.00728402912890558 -1.17716465462101 1.18130347506942
   0:
   0:
   p 0
   1
   -1: 632
   -3: 0.0960376381713132 -1.13233934150746 1.18561059374213
   0:
   0:
   p 0
   1
   -1: 633
   -3: 0.145215944461937 -1.02882158572527 1.18696485535022
   0:
   0:
   p 0
   1
   -1: 634
   -3: 0.112735314407013 -0.922484115585008 1.18459091786993
   0:
   0:
   p 0
   1
   -1: 635
   -3: 0.017902759138943 -0.871340316070529 1.17985170209072
   0:
   0:
   p 0
   1
   -1: 636
   -3: -0.0863063540261532 -0.899954841212962 1.17536053191563
   0:
   0:
   p 0
   1
   -1: 637
   -3: -0.146627106604183 -0.989325129961585 1.17337983264492
   0:
   0:
   p 0
   1
   -1: 638
   -3: -0.135481154434303 -1.09275749475028 1.17476649951079
   0:
   0:
   p 0
   1
   -1: 639
   -3: -0.0596221660099406 -1.15950257703923 1.17877841305921
   0:
   0:
   p 0
   1
   -1: 640
   -3: 0.0436453722130823 -1.15589083287306 1.18343377466606
   0:
   0:
   p 0
   1
   -1: 641
   -3: 0.121124753696217 -1.08201033511658 1.18632240966933
   0:
   0:
   p 0
   1
   -1: 642
   -3: 0.130407426880162 -0.976258378819886 1.18584828938989
   0:
   0:
   p 0
   1
   -1: 643
   -3: 0.0667061975951639 -0.896465963158066 1.18228111959166
   0:
   0:
   p 0
   1
   -1: 644
   -3: -0.0333775882407338 -0.884689033569488 1.17763575179283
   0:
   0:
   p 0
   1
   -1: 645
   -3: -0.11620017516932 -0.943579486858577 1.17437328153174
   0:
   0:
   p 0
   1
   -1: 646
   -3: -0.141385607841675 -1.04009239813849 1.17405020878581
   0:
   0:
   p 0
   1
   -1: 647
   -3: -0.0984782158138502 -1.12572574687613 1.17672746001865
   0:
   0:
   p 0
   1
   -1: 648
   -3: -0.00896929836128223 -1.15828153813018 1.18106697672727
   0:
   0:
   p 0
   1
   -1: 649
   -3: 0.0822428938835101 -1.12025603692357 1.18488276313435
   0:
   0:
   p 0
   1
   -1: 650
   -3: 0.126737536009345 -1.0301522306089 1.18613811498198
   0:
   0:
   p 0
   1
   -1: 651
   -3: 0.0999406577479181 -0.936399440330229 1.18412828570584
   0:
   0:
   p 0
   1
   -1: 652
   -3: 0.0176882227501885 -0.889863496943662 1.17999934961858
   0:
   0:
   p 0
   1
   -1: 653
   -3: -0.0743102561923373 -0.913176606586445 1.17601823635377
   0:
   0:
   p 0
   1
   -1: 654
   -3: -0.128833352503989 -0.99088876296921 1.17420187423888
   0:
   0:
   p 0
   1
   -1: 655
   -3: -0.120546792113969 -1.08224433635482 1.17535557357964
   0:
   0:
   p 0
   1
   -1: 656
   -3: -0.0546926279555458 -1.142079134736 1.17885435495918
   0:
   0:
   p 0
   1
   -1: 657
   -3: 0.0360408645607515 -1.1402218654105 1.18295612716654
   0:
   0:
   p 0
   1
   -1: 658
   -3: 0.10489855101967 -1.07638498515392 1.18553895706935
   0:
   0:
   p 0
   1
   -1: 659
   -3: 0.114517825664562 -0.983783158250439 1.1851912134204
   0:
   0:
   p 0
   1
   -1: 660
   -3: 0.059969559965406 -0.912760969024389 1.18211359103597
   0:
   0:
   p 0
   1
   -1: 661
   -3: -0.027632105759123 -0.900703136127132 1.17803296123475
   0:
   0:
   p 0
   1
   -1: 662
   -3: -0.101384921687884 -0.951134758473471 1.17511091812342
   0:
   0:
   p 0
   1
   -1: 663
   -3: -0.125008717064228 -1.03579146351561 1.17475778530643
   0:
   0:
   p 0
   1
   -1: 664
   -3: -0.0884102335666168 -1.1118591595133 1.17706689186332
   0:
   0:
   p 0
   1
   -1: 665
   -3: -0.0101371071401654 -1.14165840714245 1.18087307508822
   0:
   0:
   p 0
   1
   -1: 666
   -3: 0.0703534269305754 -1.10938958440436 1.18425152240036
   0:
   0:
   p 0
   1
   -1: 667
   -3: 0.110506459116621 -1.03093277486398 1.18540854420219
   0:
   0:
   p 0
   1
   -1: 668
   -3: 0.0883943117314558 -0.9483110276953 1.18370530186071
   0:
   0:
   p 0
   1
   -1: 669
   -3: 0.0170270053767138 -0.906128492102658 1.18010749933406
   0:
   0:
   p 0
   1
   -1: 670
   -3: -0.0641251502065188 -0.925098465276545 1.17658247755746
   0:
   0:
   p 0
   1
   -1: 671
   -3: -0.113268852988752 -0.992667979855305 1.1749243331583
   0:
   0:
   p 0
   1
   -1: 672
   -3: -0.107254773960666 -1.07329313348488 1.17588328973272
   0:
   0:
   p 0
   1
   -1: 673
   -3: -0.0500893005724186 -1.12684920777186 1.1789340951221
   0:
   0:
   p 0
   1
   -1: 674
   -3: 0.0296148431017373 -1.12632858663607 1.18254690794029
   0:
   0:
   p 0
   1
   -1: 675
   -3: 0.0907644388543969 -1.07114664864313 1.18485355296929
   0:
   0:
   p 0
   1
   -1: 676
   -3: 0.100426962541522 -0.990053860822134 1.18460506886105
   0:
   0:
   p 0
   1
   -1: 677
   -3: 0.0536812735539481 -0.926913785721309 1.18194823450113
   0:
   0:
   p 0
   1
   -1: 678
   -3: -0.0229812651514627 -0.914914052183376 1.17836505216909
   0:
   0:
   p 0
   1
   -1: 679
   -3: -0.0885654175365606 -0.958114817613223 1.17575285817917
   0:
   0:
   p 0
   1
   -1: 680
   -3: -0.110564108040799 -1.03233833868254 1.17538471384367
   0:
   0:
   p 0
   1
   -1: 681
   -3: -0.0793534831886416 -1.09984255471175 1.17737611063953
   0:
   0:
   p 0
   1
   -1: 682
   -3: -0.0109166895122289 -1.12703166989432 1.18071368744255
   0:
   0:
   p 0
   1
   -1: 683
   -3: 0.0600907085776576 -1.09964943757313 1.18370351301928
   0:
   0:
   p 0
   1
   -1: 684
   -3: 0.09625451710104 -1.03131576162986 1.18476530343225
   0:
   0:
   p 0
   1
   -1: 685
   -3: 0.0780175321781677 -0.958526526661774 1.18332100335044
   0:
   0:
   p 0
   1
   -1: 686
   -3: 0.0160770368207971 -0.920403094812413 1.18018561082472
   0:
   0:
   p 0
   1
   -1: 687
   -3: -0.055460384014985 -0.935806860379964 1.1770672369649
   0:
   0:
   p 0
   1
   -1: 688
   -3: -0.0996547861395426 -0.99455106091473 1.17555896331454
   0:
   0:
   p 0
   1
   -1: 689
   -3: -0.0954445515875066 -1.0656583534264 1.17635486144978
   0:
   0:
   p 0
   1
   -1: 690
   -3: -0.0458290526487751 -1.11353401932548 1.17901450493646
   0:
   0:
   p 0
   1
   -1: 691
   -3: 0.0241727715484062 -1.11402457761113 1.18219573958076
   0:
   0:
   p 0
   1
   -1: 692
   -3: 0.0784462437722574 -1.06631247815866 1.18425385241666
   0:
   0:
   p 0
   1
   -1: 693
   -3: 0.0879496234890678 -0.995293843909697 1.18408336074813
   0:
   0:
   p 0
   1
   -1: 694
   -3: 0.0478691070648979 -0.939213393090474 1.18178876385521
   0:
   0:
   p 0
   1
   -1: 695
   -3: -0.0192105022425486 -0.927504122832315 1.1786433446123
   0:
   0:
   p 0
   1
   -1: 696
   -3: -0.0774641016630633 -0.964515932349309 1.17631171806608
   0:
   0:
   p 0
   1
   -1: 697
   -3: -0.0978330027670107 -1.02956574041508 1.17593953048602
   0:
   0:
   p 0
   1
   -1: 698
   -3: -0.0712287884475883 -1.08942141539612 1.17765655108981
   0:
   0:
   p 0
   1
   -1: 699
   -3: -0.0114034919540533 -1.11416612522108 1.18058249952012
   0:
   0:
   p 0
   1
   -1: 700
   -3: 0.0512224890054671 -1.09093979608333 1.18322742137678
   0:
   0:
   p 0
   1
   -1: 701
   -3: 0.0837437189690963 -1.03141203814031 1.18419855870734
   0:
   0:
   p 0
   1
   -1: 702
   -3: 0.0687208999444816 -0.967300431581719 1.18297349215376
   0:
   0:
   p 0
   1
   -1: 703
   -3: 0.0149505451848965 -0.932926056372809 1.1802408162486
   0:
   0:
   p 0
   1
   -1: 704
   -3: -0.0480772030161184 -0.945396876064948 1.17748420032528
   0:
   0:
   p 0
   1
   -1: 705
   -3: -0.087746982576694 -0.996461300611746 1.17611623334316
   0:
   0:
   p 0
   1
   -1: 706
   -3: -0.084964529367728 -1.05913795428775 1.17677546412562
   0:
   0:
   p 0
   1
   -1: 707
   -3: -0.0419117274221674 -1.10189134171161 1.17909353786534
   0:
   0:
   p 0
   1
   -1: 708
   -3: 0.0195573284273572 -1.10313775576807 1.18189404641077
   0:
   0:
   p 0
   1
   -1: 709
   -3: 0.0677065847939775 -1.06188015138831 1.18372909688133
   0:
   0:
   p 0
   1
   -1: 710
   -3: 0.0769134213812226 -0.999681183201663 1.18361978508987
   0:
   0:
   p 0
   1
   -1: 711
   -3: 0.0425359987545019 -0.94990765024192 1.18163741623229
   0:
   0:
   p 0
   1
   -1: 712
   -3: -0.0161510619840487 -0.938644035149921 1.1788769721487
   0:
   0:
   p 0
   1
   -1: 713
   -3: -0.0678446586875254 -0.970353392719141 1.17679839405905
   0:
   0:
   p 0
   1
   -1: 714
   -3: -0.0866184856816957 -1.0273422633811 1.17643007962145
   0:
   0:
   p 0
   1
   -1: 715
   -3: -0.0639553120960174 -1.08037916344729 1.17791004523248
   0:
   0:
   p 0
   1
   -1: 716
   -3: -0.0116689029922368 -1.1028528485823 1.18047450759565
   0:
   0:
   p 1
   msg=Last point
   bif=0
   1
   -1: 717
   -3: 0.0435534470885737 -1.08316546122728 1.18281360443287
   -7: 1.167 0.2 0.01 2 1
     4 0.1
   0:
   -
   a=2
   1
    c=1, u=0
    1:
    (-1000,3,-1) (-1000,2,-1) (-1000,2,0)
   1
    c=1, u=0
    1:
    (-1000,3,-1) (-1000,2,-1) (-1000,2,0)
   t=1
    720 1
    6: 717 0.0435534470885737 -1.08316546122728 1.18281360443287 718
     1000
    0:
   b=0
   m=-1,-1
   slvpar=0
  c0  outPoint->Orbit (+)
   types=1,1
   p m__o.h
   fields=7
    field0 dim=1 1
    field1 dim=0
    field2 dim=1 0
    field3 dim=3 -2.27 1.34831460674157 0.16
    field4 dim=7 1.167 0.2 0.01 2 1
      4 0.1
    field5 dim=0
    field6 unique=0 selected=0
   expr=0
   p _iter.h
   fields=3
    field2 dim=1 1000
   expr=0
   f m__o
   from=1,1 to=5000,500 step=1,1
   n=4
   relclass=0: 1 [0,-1]
   relclass=1: 1 [0,-3]
   relclass=2: 0
   relclass=3: 0
   spec= 1 3 7 0
   u=0
   cl=4 7
   p 0
   1
   -1: 0
   -3: -2.27 1.34831460674157 0.16
   0:
   0:
   p 0
   1
   -1: 1
   -3: -2.94787412211833 0.340102413873744 1.0326545451559
   0:
   0:
   p 0
   1
   -1: 2
   -3: -3.33520912273898 -0.830724030168402 1.02529457215557
   0:
   0:
   p 0
   1
   -1: 3
   -3: -3.38466252414647 -1.8307455478417 1.03204827846587
   0:
   0:
   p 0
   1
   -1: 4
   -3: -3.18935089337698 -2.70780206653713 1.04892900463334
   0:
   0:
   p 0
   1
   -1: 5
   -3: -2.71237918591435 -3.5108452461322 1.07794590708461
   0:
   0:
   p 0
   1
   -1: 6
   -3: -1.78357469934248 -4.22528999292739 1.12650561327835
   0:
   0:
   p 0
   1
   -1: 7
   -3: -0.089155122845764 -4.56982847186594 1.20586896598721
   0:
   0:
   p 0
   1
   -1: 8
   -3: 2.3384190709275 -3.50602573767217 1.30538912035031
   0:
   0:
   p 0
   1
   -1: 9
   -3: 3.30750475141908 -0.184238347465279 1.3219369058632
   0:
   0:
   p 0
   1
   -1: 10
   -3: 1.029388928728 2.23517696366495 1.1993110958015
   0:
   0:
   p 0
   1
   -1: 11
   -3: -1.45249523878145 1.93718835145515 1.08770120345496
   0:
   0:
   p 0
   1
   -1: 12
   -3: -2.74297793769291 0.702255871836723 1.0388938606423
   0:
   0:
   p 0
   1
   -1: 13
   -3: -3.26849596830831 -0.516163925313772 1.02553535073054
   0:
   0:
   p 0
   1
   -1: 14
   -3: -3.39786202242627 -1.56126595055132 1.02900527580377
   0:
   0:
   p 0
   1
   -1: 15
   -3: -3.27107055348267 -2.46720825601582 1.0430122152249
   0:
   0:
   p 0
   1
   -1: 16
   -3: -2.88564754628141 -3.2880558201156 1.0680409387205
   0:
   0:
   p 0
   1
   -1: 17
   -3: -2.11319252749089 -4.03803516687103 1.10990414211449
   0:
   0:
   p 0
   1
   -1: 18
   -3: -0.672343265476786 -4.55107985571902 1.17951048616206
   0:
   0:
   p 0
   1
   -1: 19
   -3: 1.63630108870596 -4.05146855261379 1.27862505043146
   0:
   0:
   p 0
   1
   -1: 20
   -3: 3.39085797202772 -1.25976785617752 1.33417830319503
   0:
   0:
   p 0
   1
   -1: 21
   -3: 1.86222501762981 1.86099621412641 1.24034829415182
   0:
   0:
   p 0
   1
   -1: 22
   -3: -0.864997252302514 2.19761408980649 1.11258848258001
   0:
   0:
   p 0
   1
   -1: 23
   -3: -2.47512293968312 1.0741454560585 1.04797865439351
   0:
   0:
   p 0
   1
   -1: 24
   -3: -3.17020441444737 -0.183183867751873 1.02707534372536
   0:
   0:
   p 0
   1
   -1: 25
   -3: -3.3911266367123 -1.27744199468593 1.02675010834901
   0:
   0:
   p 0
   1
   -1: 26
   -3: -3.33323698636783 -2.21724263045354 1.03790196460944
   0:
   0:
   p 0
   1
   -1: 27
   -3: -3.03000675095408 -3.05784100652851 1.05937413269105
   0:
   0:
   p 0
   1
   -1: 28
   -3: -2.39188712081097 -3.83246223420141 1.09541315091055
   0:
   0:
   p 0
   1
   -1: 29
   -3: -1.18177542609332 -4.45520238665347 1.15572539368983
   0:
   0:
   p 0
   1
   -1: 30
   -3: 0.90151045772584 -4.38904612972733 1.24867035075712
   0:
   0:
   p 0
   1
   -1: 31
   -3: 3.14472778988696 -2.30283149486074 1.33152436879655
   0:
   0:
   p 0
   1
   -1: 32
   -3: 2.61684864087714 1.20095281136687 1.27986103356709
   0:
   0:
   p 0
   1
   -1: 33
   -3: -0.157603193327511 2.34795688225054 1.14390981072852
   0:
   0:
   p 0
   1
   -1: 34
   -3: -2.12777432789463 1.44663483869013 1.06075887611898
   0:
   0:
   p 0
   1
   -1: 35
   -3: -3.03268511290707 0.16948395249591 1.0302613304398
   0:
   0:
   p 0
   1
   -1: 36
   -3: -3.36196838999031 -0.976619477301773 1.02537602648341
   0:
   0:
   p 0
   1
   -1: 37
   -3: -3.37641313637715 -1.95566524317413 1.03355467143648
   0:
   0:
   p 0
   1
   -1: 38
   -3: -3.14906077804331 -2.81945681575037 1.05177897500805
   0:
   0:
   p 0
   1
   -1: 39
   -3: -2.62704499096182 -3.61343742331897 1.08275187139696
   0:
   0:
   p 0
   1
   -1: 40
   -3: -1.62014254113155 -4.30601202325556 1.13461240144178
   0:
   0:
   p 0
   1
   -1: 41
   -3: 0.192979182128361 -4.55069219306828 1.21834944432297
   0:
   0:
   p 0
   1
   -1: 42
   -3: 2.6229538810993 -3.19651573785657 1.31552058199461
   0:
   0:
   p 0
   1
   -1: 43
   -3: 3.16929640682579 0.272478497542117 1.3121236289721
   0:
   0:
   p 0
   1
   -1: 44
   -3: 0.659660501876952 2.32295432378918 1.18165528382982
   0:
   0:
   p 0
   1
   -1: 45
   -3: -1.68064601634845 1.80257163994437 1.07832220278939
   0:
   0:
   p 0
   1
   -1: 46
   -3: -2.84516870707196 0.542051011861318 1.03559516615276
   0:
   0:
   p 0
   1
   -1: 47
   -3: -3.30636642587844 -0.655785480064669 1.02504440400654
   0:
   0:
   p 0
   1
   -1: 48
   -3: -3.4002105128341 -1.6796713192461 1.02996520750624
   0:
   0:
   p 0
   1
   -1: 49
   -3: -3.24541594904829 -2.57125871648825 1.04512527231105
   0:
   0:
   p 0
   1
   -1: 50
   -3: -2.82504506912276 -3.38323271362525 1.07165947979843
   0:
   0:
   p 0
   1
   -1: 51
   -3: -1.9941710442211 -4.12010979399652 1.116029127776
   0:
   0:
   p 0
   1
   -1: 52
   -3: -0.455650481771205 -4.57581704539287 1.18946447542303
   0:
   0:
   p 0
   1
   -1: 53
   -3: 1.91997247244674 -3.87133125733266 1.28976528911457
   0:
   0:
   p 0
   1
   -1: 54
   -3: 3.40492025759017 -0.837509523464936 1.33145875050192
   0:
   0:
   p 0
   1
   -1: 55
   -3: 1.54271309474556 2.04593440732152 1.22429657975447
   0:
   0:
   p 0
   1
   -1: 56
   -3: -1.11101723509192 2.11166027351355 1.10196697500819
   0:
   0:
   p 0
   1
   -1: 57
   -3: -2.5925445386085 0.932464546411073 1.0438009267365
   0:
   0:
   p 0
   1
   -1: 58
   -3: -3.21813652590052 -0.311602724662521 1.02601462325481
   0:
   0:
   p 0
   1
   -1: 59
   -3: -3.40307276878564 -1.3857742611884 1.02717612593157
   0:
   0:
   p 0
   1
   -1: 60
   -3: -3.32067559388523 -2.31073635647531 1.03932012146999
   0:
   0:
   p 0
   1
   -1: 61
   -3: -2.99111379247774 -3.14214853053847 1.06190762235244
   0:
   0:
   p 0
   1
   -1: 62
   -3: -2.31191767798095 -3.90816227595463 1.09972019845751
   0:
   0:
   p 0
   1
   -1: 63
   -3: -1.03028711014053 -4.50081424687795 1.16295173791125
   0:
   0:
   p 0
   1
   -1: 64
   -3: 1.13581329885322 -4.3110157262766 1.25847125252502
   0:
   0:
   p 0
   1
   -1: 65
   -3: 3.26415385513833 -1.98551491913386 1.3343006069034
   0:
   0:
   p 0
   1
   -1: 66
   -3: 2.39707599653866 1.4491309198357 1.26793238756786
   0:
   0:
   p 0
   1
   -1: 67
   -3: -0.398584789462039 2.32324847087198 1.13301940053309
   0:
   0:
   p 0
   1
   -1: 68
   -3: -2.25374090723793 1.33403488121559 1.05591956188736
   0:
   0:
   p 0
   1
   -1: 69
   -3: -3.0878956051092 0.0594015402686731 1.02869423046744
   0:
   0:
   p 0
   1
   -1: 70
   -3: -3.38186380189901 -1.06963086244458 1.02529546326703
   0:
   0:
   p 0
   1
   -1: 71
   -3: -3.37534037288365 -2.0344249177493 1.0343120690487
   0:
   0:
   p 0
   1
   -1: 72
   -3: -3.129273793338 -2.88886705201867 1.05330644148172
   0:
   0:
   p 0
   1
   -1: 73
   -3: -2.5812571146906 -3.67622060325911 1.0853951505772
   0:
   0:
   p 0
   1
   -1: 74
   -3: -1.52926505805159 -4.35451939547016 1.13914487842793
   0:
   0:
   p 0
   1
   -1: 75
   -3: 0.350697542681681 -4.53789053462631 1.22529849002603
   0:
   0:
   p 0
   1
   -1: 76
   -3: 2.76996241399351 -3.0163171175939 1.32059309287986
   0:
   0:
   p 0
   1
   -1: 77
   -3: 3.0754185445461 0.511783489936216 1.30600649309715
   0:
   0:
   p 0
   1
   -1: 78
   -3: 0.462225335866069 2.35847616715905 1.17230131866071
   0:
   0:
   p 0
   1
   -1: 79
   -3: -1.79996943037559 1.7307967478159 1.07342618472096
   0:
   0:
   p 0
   1
   -1: 80
   -3: -2.90137983678192 0.460237257069824 1.03372280012851
   0:
   0:
   p 0
   1
   -1: 81
   -3: -3.33114069702308 -0.725828039538645 1.02452889998938
   0:
   0:
   p 0
   1
   -1: 82
   -3: -3.40856719752564 -1.7376891384858 1.03010064890797
   0:
   0:
   p 0
   1
   -1: 83
   -3: -3.24229930753168 -2.62056699632453 1.04570817268633
   0:
   0:
   p 0
   1
   -1: 84
   -3: -2.80912504411485 -3.42675733852062 1.07277136601825
   0:
   0:
   p 0
   1
   -1: 85
   -3: -1.957536955776 -4.15741561278119 1.11801541218177
   0:
   0:
   p 0
   1
   -1: 86
   -3: -0.383921174175113 -4.59218063401235 1.19282296634919
   0:
   0:
   p 0
   1
   -1: 87
   -3: 2.01648237713698 -3.8145992487974 1.29358845061297
   0:
   0:
   p 0
   1
   -1: 88
   -3: 3.40873852759088 -0.697034012117295 1.33051317758437
   0:
   0:
   p 0
   1
   -1: 89
   -3: 1.43746472788353 2.10824993206732 1.21898389134048
   0:
   0:
   p 0
   1
   -1: 90
   -3: -1.19401779389845 2.08870208081545 1.09832599900347
   0:
   0:
   p 0
   1
   -1: 91
   -3: -2.63670214606813 0.891876253758355 1.04211344659079
   0:
   0:
   p 0
   1
   -1: 92
   -3: -3.24185615440453 -0.347675773631264 1.02523865718574
   0:
   0:
   p 0
   1
   -1: 93
   -3: -3.41767198980157 -1.41434642897542 1.02675634770674
   0:
   0:
   p 0
   1
   -1: 94
   -3: -3.33158209893316 -2.33279790621218 1.03901266506816
   0:
   0:
   p 0
   1
   -1: 95
   -3: -3.00115149663841 -3.15931306281157 1.06159671237413
   0:
   0:
   p 0
   1
   -1: 96
   -3: -2.32277527269239 -3.92249830412388 1.09934777726033
   0:
   0:
   p 0
   1
   -1: 97
   -3: -1.04228448895786 -4.51584672149845 1.16253548424731
   0:
   0:
   p 0
   1
   -1: 98
   -3: 1.12787043517471 -4.33191333577792 1.25828552446709
   0:
   0:
   p 0
   1
   -1: 99
   -3: 3.27479747636982 -2.00590559855128 1.3349305525921
   0:
   0:
   p 0
   1
   -1: 100
   -3: 2.41609793024136 1.45298628302666 1.26875639893725
   0:
   0:
   p 0
   1
   -1: 101
   -3: -0.394533436419115 2.33991120190398 1.13305811652286
   0:
   0:
   p 0
   1
   -1: 102
   -3: -2.25997455147874 1.34930133167167 1.05548961352563
   0:
   0:
   p 0
   1
   -1: 103
   -3: -3.0989822765505 0.0728108080689868 1.02805448352819
   0:
   0:
   p 0
   1
   -1: 104
   -3: -3.39714409559069 -1.05608441417036 1.02446147480254
   0:
   0:
   p 0
   1
   -1: 105
   -3: -3.39677703933557 -2.01907874021218 1.03318057659809
   0:
   0:
   p 0
   1
   -1: 106
   -3: -3.16140682707904 -2.87072968836708 1.05166373723519
   0:
   0:
   p 0
   1
   -1: 107
   -3: -2.63301069627192 -3.65650876570918 1.08285295736186
   0:
   0:
   p 0
   1
   -1: 108
   -3: -1.61646253039995 -4.34384221822748 1.13509947012897
   0:
   0:
   p 0
   1
   -1: 109
   -3: 0.216176092759166 -4.57962432167388 1.21962285237635
   0:
   0:
   p 0
   1
   -1: 110
   -3: 2.6672638781676 -3.1898143466892 1.31742406795625
   0:
   0:
   p 0
   1
   -1: 111
   -3: 3.18038990290411 0.326654647958678 1.31218095125417
   0:
   0:
   p 0
   1
   -1: 112
   -3: 0.623821619371475 2.35913840442725 1.17969969580012
   0:
   0:
   p 0
   1
   -1: 113
   -3: -1.71905255773405 1.81174099241964 1.07645331232098
   0:
   0:
   p 0
   1
   -1: 114
   -3: -2.87709096008861 0.544102519139946 1.03408734551126
   0:
   0:
   p 0
   1
   -1: 115
   -3: -3.33672529692014 -0.651652205314756 1.02359269410506
   0:
   0:
   p 0
   1
   -1: 116
   -3: -3.43504168491872 -1.67013307197471 1.02826209528915
   0:
   0:
   p 0
   1
   -1: 117
   -3: -3.2920805223382 -2.55492824608462 1.04282300204231
   0:
   0:
   p 0
   1
   -1: 118
   -3: -2.89529178860843 -3.36088205208658 1.06823621508288
   0:
   0:
   p 0
   1
   -1: 119
   -3: -2.10866970549234 -4.10109160354774 1.11065044159345
   0:
   0:
   p 0
   1
   -1: 120
   -3: -0.641015620908983 -4.60288837065094 1.18134990633643
   0:
   0:
   p 0
   1
   -1: 121
   -3: 1.70793936755588 -4.06160135364014 1.28188171238353
   0:
   0:
   p 0
   1
   -1: 122
   -3: 3.44169733432634 -1.17839939163131 1.33578296692682
   0:
   0:
   p 0
   1
   -1: 123
   -3: 1.81220158999464 1.94493383526429 1.23737489202915
   0:
   0:
   p 0
   1
   -1: 124
   -3: -0.937849420026188 2.21919649916792 1.10902210892848
   0:
   0:
   p 0
   1
   -1: 125
   -3: -2.53195967718166 1.07155182504372 1.04535238559061
   0:
   0:
   p 0
   1
   -1: 126
   -3: -3.21751117151394 -0.185914638180957 1.02489482884403
   0:
   0:
   p 0
   1
   -1: 127
   -3: -3.43941972225958 -1.272572537149 1.0244605486407
   0:
   0:
   p 0
   1
   -1: 128
   -3: -3.39282911761478 -2.20208799874378 1.03500634305191
   0:
   0:
   p 0
   1
   -1: 129
   -3: -3.11482928349861 -3.03205661302729 1.05523868169501
   0:
   0:
   p 0
   1
   -1: 130
   -3: -2.52558392675867 -3.8023647779686 1.08903782612621
   0:
   0:
   p 0
   1
   -1: 131
   -3: -1.40216756517946 -4.45494074130171 1.14575064129119
   0:
   0:
   p 0
   1
   -1: 132
   -3: 0.586560537345984 -4.54006687564159 1.23584884674789
   0:
   0:
   p 0
   1
   -1: 133
   -3: 2.99199785299097 -2.752658993596 1.32831850604274
   0:
   0:
   p 0
   1
   -1: 134
   -3: 2.93409436676164 0.864137860809465 1.29683268589016
   0:
   0:
   p 0
   1
   -1: 135
   -3: 0.173367431505512 2.42021626008952 1.15850044173232
   0:
   0:
   p 0
   1
   -1: 136
   -3: -1.98487606455858 1.64460535609026 1.06560661953262
   0:
   0:
   p 0
   1
   -1: 137
   -3: -3.00358749160891 0.360484566755064 1.0298689066306
   0:
   0:
   p 0
   1
   -1: 138
   -3: -3.39527251791937 -0.806735519593701 1.02227947769109
   0:
   0:
   p 0
   1
   -1: 139
   -3: -3.45927864596871 -1.796901471307 1.02828099514695
   0:
   0:
   p 0
   1
   -1: 140
   -3: -3.29408848737117 -2.66084353616961 1.04367373939363
   0:
   0:
   p 0
   1
   -1: 141
   -3: -2.87458341661906 -3.45284993966847 1.06999329182184
   0:
   0:
   p 0
   1
   -1: 142
   -3: -2.05232539335385 -4.18091418635492 1.11390031264471
   0:
   0:
   p 0
   1
   -1: 143
   -3: -0.521840495356824 -4.64976303624939 1.18709873419526
   0:
   0:
   p 0
   1
   -1: 144
   -3: 1.88639738340747 -3.98645128476246 1.28919095794947
   0:
   0:
   p 0
   1
   -1: 145
   -3: 3.48111963905027 -0.928935700342205 1.33555448156089
   0:
   0:
   p 0
   1
   -1: 146
   -3: 1.63093984839866 2.08424093762095 1.22797628523284
   0:
   0:
   p 0
   1
   -1: 147
   -3: -1.09801850701243 2.19410808783898 1.10182664750263
   0:
   0:
   p 0
   1
   -1: 148
   -3: -2.62318977299439 1.00701823606342 1.0416885196624
   0:
   0:
   p 0
   1
   -1: 149
   -3: -3.27195086282262 -0.24348844808482 1.02288298435607
   0:
   0:
   p 0
   1
   -1: 150
   -3: -3.47950902620855 -1.31523189971383 1.02298318949015
   0:
   0:
   p 0
   1
   -1: 151
   -3: -3.43118357070806 -2.23029499018026 1.03348249626528
   0:
   0:
   p 0
   1
   -1: 152
   -3: -3.16118666978562 -3.04790992533856 1.05324204111918
   0:
   0:
   p 0
   1
   -1: 153
   -3: -2.59176727791501 -3.8105789636973 1.08607961898463
   0:
   0:
   p 0
   1
   -1: 154
   -3: -1.50481836840632 -4.47172651518269 1.14124183882676
   0:
   0:
   p 0
   1
   -1: 155
   -3: 0.443567450124981 -4.61836571241118 1.23010008141581
   0:
   0:
   p 0
   1
   -1: 156
   -3: 2.91834626812608 -2.96190460509812 1.32671171039503
   0:
   0:
   p 0
   1
   -1: 157
   -3: 3.08106416831856 0.703040746492546 1.30470848080447
   0:
   0:
   p 0
   1
   -1: 158
   -3: 0.328843449886424 2.46044102408778 1.1652890962527
   0:
   0:
   p 0
   1
   -1: 159
   -3: -1.92528242706228 1.74687647250035 1.06744837251016
   0:
   0:
   p 0
   1
   -1: 160
   -3: -3.00139074455833 0.458630271035917 1.02907105407545
   0:
   0:
   p 0
   1
   -1: 161
   -3: -3.42495925118346 -0.717852556816714 1.02008579293346
   0:
   0:
   p 0
   1
   -1: 162
   -3: -3.5159252572688 -1.71075951751636 1.0248728445544
   0:
   0:
   p 0
   1
   -1: 163
   -3: -3.38635772589496 -2.57053815124301 1.03860269517849
   0:
   0:
   p 0
   1
   -1: 164
   -3: -3.02665220201862 -3.35526566220893 1.06214688743283
   0:
   0:
   p 0
   1
   -1: 165
   -3: -2.31406673215286 -4.09086852549383 1.1011945109678
   0:
   0:
   p 0
   1
   -1: 166
   -3: -0.970077346231159 -4.65753565367918 1.1669757641242
   0:
   0:
   p 0
   1
   -1: 167
   -3: 1.3067798475376 -4.38388240948593 1.26665159404885
   0:
   0:
   p 0
   1
   -1: 168
   -3: 3.4449080490486 -1.81848030985283 1.34096267149169
   0:
   0:
   p 0
   1
   -1: 169
   -3: 2.31135850323138 1.70473911525492 1.26194602725691
   0:
   0:
   p 0
   1
   -1: 170
   -3: -0.596687721309798 2.41474368388314 1.12305411743001
   0:
   0:
   p 0
   1
   -1: 171
   -3: -2.41765404319583 1.3417359636981 1.04820769093343
   0:
   0:
   p 0
   1
   -1: 172
   -3: -3.22392890511412 0.0601448916442038 1.02234100594651
   0:
   0:
   p 0
   1
   -1: 173
   -3: -3.51856222929822 -1.04901702089377 1.01874522482936
   0:
   0:
   p 0
   1
   -1: 174
   -3: -3.54115800125475 -1.98377993730653 1.02616599902981
   0:
   0:
   p 0
   1
   -1: 175
   -3: -3.36149765225119 -2.80354529580209 1.04182919949865
   0:
   0:
   p 0
   1
   -1: 176
   -3: -2.94305649002835 -3.56342422138466 1.06781572547742
   0:
   0:
   p 0
   1
   -1: 177
   -3: -2.13243419095209 -4.27555409594886 1.11106044852536
   0:
   0:
   p 0
   1
   -1: 178
   -3: -0.612734196411955 -4.75914335818386 1.18391424080037
   0:
   0:
   p 0
   1
   -1: 179
   -3: 1.84074010540651 -4.15023741070427 1.28846694353452
   0:
   0:
   p 0
   1
   -1: 180
   -3: 3.59023935798013 -1.05729895348038 1.34139096892457
   0:
   0:
   p 0
   1
   -1: 181
   -3: 1.75449728991732 2.14304414450782 1.23308304463295
   0:
   0:
   p 0
   1
   -1: 182
   -3: -1.08444300999373 2.31365479768119 1.10137795269364
   0:
   0:
   p 0
   1
   -1: 183
   -3: -2.67083806862449 1.11395792569311 1.03848303387477
   0:
   0:
   p 0
   1
   -1: 184
   -3: -3.35130036456943 -0.144828145645967 1.01827653646266
   0:
   0:
   p 0
   1
   -1: 185
   -3: -3.59005981787619 -1.21091819110343 1.01689032654571
   0:
   0:
   p 0
   1
   -1: 186
   -3: -3.58893487799203 -2.10811524322843 1.02506953229802
   0:
   0:
   p 0
   1
   -1: 187
   -3: -3.4011164596498 -2.89845314030833 1.04084324150253
   0:
   0:
   p 0
   1
   -1: 188
   -3: -2.98357050861509 -3.63676866135969 1.06659659424113
   0:
   0:
   p 0
   1
   -1: 189
   -3: -2.18006463123905 -4.33734365238059 1.10941897322788
   0:
   0:
   p 0
   1
   -1: 190
   -3: -0.667107625801492 -4.8279147508022 1.18203659518906
   0:
   0:
   p 0
   1
   -1: 191
   -3: 1.81284458801901 -4.25070080944159 1.28802750037982
   0:
   0:
   p 0
   1
   -1: 192
   -3: 3.65696581448397 -1.13639915089442 1.344959879433
   0:
   0:
   p 0
   1
   -1: 193
   -3: 1.8300081873763 2.18042858702615 1.23619022187764
   0:
   0:
   p 0
   1
   -1: 194
   -3: -1.07785125951394 2.38798578227419 1.10101266619736
   0:
   0:
   p 0
   1
   -1: 195
   -3: -2.70147822662649 1.18011011172223 1.03644373004754
   0:
   0:
   p 0
   1
   -1: 196
   -3: -3.40074779779587 -0.0832091011055999 1.01540167348397
   0:
   0:
   p 0
   1
   -1: 197
   -3: -3.65799117651055 -1.14466411297237 1.01312210149929
   0:
   0:
   p 0
   1
   -1: 198
   -3: -3.68473884668548 -2.02893201794874 1.01990720168549
   0:
   0:
   p 0
   1
   -1: 199
   -3: -3.54496178612877 -2.7985586517218 1.03330183198441
   0:
   0:
   p 0
   1
   -1: 200
   -3: -3.21553277829154 -3.51164457507606 1.05483035976442
   0:
   0:
   p 0
   1
   -1: 201
   -3: -2.58003978515996 -4.20433199393695 1.09002275642652
   0:
   0:
   p 0
   1
   -1: 202
   -3: -1.37085202364249 -4.80951427189742 1.1501445656133
   0:
   0:
   p 0
   1
   -1: 203
   -3: 0.810146960533903 -4.80434187782265 1.24794075039952
   0:
   0:
   p 0
   1
   -1: 204
   -3: 3.3906745536968 -2.64228634872094 1.34501479350712
   0:
   0:
   p 0
   1
   -1: 205
   -3: 2.9562289934074 1.35591258232015 1.29380525400119
   0:
   0:
   p 0
   1
   -1: 206
   -3: -0.156644891896292 2.70482663025122 1.14078815376299
   0:
   0:
   p 0
   1
   -1: 207
   -3: -2.31359451492629 1.7391998343489 1.04941471139951
   0:
   0:
   p 0
   1
   -1: 208
   -3: -3.29277172753488 0.423959524618399 1.01577652957698
   0:
   0:
   p 0
   1
   -1: 209
   -3: -3.6919039997479 -0.705844344156606 1.00752448303201
   0:
   0:
   p 0
   1
   -1: 210
   -3: -3.81882778994948 -1.6272626288872 1.01002837716539
   0:
   0:
   p 0
   1
   -1: 211
   -3: -3.79022879128678 -2.39883587692837 1.01834802477926
   0:
   0:
   p 0
   1
   -1: 212
   -3: -3.63147697957607 -3.08078095430715 1.03181924031973
   0:
   0:
   p 0
   1
   -1: 213
   -3: -3.30471598587629 -3.72641719111668 1.0526156832329
   0:
   0:
   p 0
   1
   -1: 214
   -3: -2.68896907497826 -4.37270364996634 1.08649663038628
   0:
   0:
   p 0
   1
   -1: 215
   -3: -1.51199212220391 -4.9677298908963 1.14508743385131
   0:
   0:
   p 0
   1
   -1: 216
   -3: 0.667601098362516 -5.02710291722366 1.24338522712522
   0:
   0:
   p 0
   1
   -1: 217
   -3: 3.43515943696861 -2.94158087431928 1.34929750188231
   0:
   0:
   p 0
   1
   -1: 218
   -3: 3.21058697840231 1.30883411988448 1.30557043224815
   0:
   0:
   p 0
   1
   -1: 219
   -3: -0.0531544115898134 2.88547399577062 1.14395600100541
   0:
   0:
   p 0
   1
   -1: 220
   -3: -2.35070046910774 1.92751992425713 1.04594740251209
   0:
   0:
   p 0
   1
   -1: 221
   -3: -3.39191653853381 0.595236937749687 1.00955272306265
   0:
   0:
   p 0
   1
   -1: 222
   -3: -3.83381360851935 -0.52875805484167 0.999264000578518
   0:
   0:
   p 0
   1
   -1: 223
   -3: -4.01361220606656 -1.42026656986444 0.999058707215728
   0:
   0:
   p 0
   1
   -1: 224
   -3: -4.06742909833336 -2.13613362880591 1.00308351157314
   0:
   0:
   p 0
   1
   -1: 225
   -3: -4.04756218053665 -2.72961529349755 1.00938464106198
   0:
   0:
   p 0
   1
   -1: 226
   -3: -3.96752596599887 -3.24395609789748 1.01772368917305
   0:
   0:
   p 0
   1
   -1: 227
   -3: -3.81439079586355 -3.71760201249698 1.02903539010291
   0:
   0:
   p 0
   1
   -1: 228
   -3: -3.54291528749336 -4.18969177001576 1.04572799117173
   0:
   0:
   p 0
   1
   -1: 229
   -3: -3.04785396298121 -4.69936681934234 1.07290319094802
   0:
   0:
   p 0
   1
   -1: 230
   -3: -2.09407131653318 -5.24844173235338 1.12107818914804
   0:
   0:
   p 0
   1
   -1: 231
   -3: -0.207910077020468 -5.57324511028176 1.2087380560234
   0:
   0:
   p 0
   1
   -1: 232
   -3: 2.87836340178445 -4.31636970694502 1.33550722587523
   0:
   0:
   p 0
   1
   -1: 233
   -3: 4.19365096675649 0.185220902945619 1.35824818007116
   0:
   0:
   p 0
   1
   -1: 234
   -3: 0.951363978711905 3.22578883204841 1.18714764553767
   0:
   0:
   p 0
   1
   -1: 235
   -3: -2.04800299895837 2.64080512194594 1.05351254854615
   0:
   0:
   p 0
   1
   -1: 236
   -3: -3.44492248019655 1.26004962552025 1.00087727359806
   0:
   0:
   p 0
   1
   -1: 237
   -3: -4.05970186996532 0.0964043842954794 0.982877779337967
   0:
   0:
   p 0
   1
   -1: 238
   -3: -4.3694177759091 -0.768464101011249 0.976400072787696
   0:
   0:
   p 0
   1
   -1: 239
   -3: -4.57023214408469 -1.38546134341391 0.972712509514803
   0:
   0:
   p 0
   1
   -1: 240
   -3: -4.75100606852829 -1.79330747950835 0.968020492290582
   0:
   0:
   p 0
   1
   -1: 241
   -3: -4.96086309880074 -2.0027863643905 0.960128737647169
   0:
   0:
   p 0
   1
   -1: 242
   -3: -5.22910959965963 -1.99789009456144 0.94750115750354
   0:
   0:
   p 0
   1
   -1: 243
   -3: -5.56170626977875 -1.74252052603078 0.929471789651414
   0:
   0:
   p 0
   1
   -1: 244
   -3: -5.92418113732743 -1.20392354108073 0.907264678523927
   0:
   0:
   p 0
   1
   -1: 245
   -3: -6.2348165751227 -0.403993422700273 0.884851776233811
   0:
   0:
   p 0
   1
   -1: 246
   -3: -6.40796635210905 0.534705478837578 0.867449260252053
   0:
   0:
   p 0
   1
   -1: 247
   -3: -6.42827418229541 1.43012539960077 0.857632665627152
   0:
   0:
   p 0
   1
   -1: 248
   -3: -6.35636489535955 2.15332491250263 0.853870422601785
   0:
   0:
   p 0
   1
   -1: 249
   -3: -6.26225059576689 2.67761046381371 0.853132801574456
   0:
   0:
   p 0
   1
   -1: 250
   -3: -6.18297530868458 3.03884954060187 0.853308026256828
   0:
   0:
   p 0
   1
   -1: 251
   -3: -6.12698355699824 3.28602621662985 0.853507400679197
   0:
   0:
   p 0
   1
   -1: 252
   -3: -6.09046041635751 3.45885368561374 0.853517874222013
   0:
   0:
   p 0
   1
   -1: 253
   -3: -6.0672636247012 3.58417549681974 0.853365653972816
   0:
   0:
   p 0
   1
   -1: 254
   -3: -6.05240942716016 3.67875595469659 0.853122014347842
   0:
   0:
   p 0
   1
   -1: 255
   -3: -6.04258537155477 3.75275602602833 0.852844100111298
   0:
   0:
   p 0
   1
   -1: 256
   -3: -6.0357792136603 3.81233914183949 0.852566679509736
   0:
   0:
   p 0
   1
   -1: 257
   -3: -6.03081987792888 3.86133280103016 0.852307544171732
   0:
   0:
   p 0
   1
   -1: 258
   -3: -6.02703590284113 3.90221179785124 0.852074052569722
   0:
   0:
   p 0
   1
   -1: 259
   -3: -6.02403976908816 3.93665873941774 0.851867870345125
   0:
   0:
   p 0
   1
   -1: 260
   -3: -6.0216020287047 3.96587871088544 0.851687864687394
   0:
   0:
   p 0
   1
   -1: 261
   -3: -6.01958097138328 3.9907762112411 0.851531706706891
   0:
   0:
   p 0
   1
   -1: 262
   -3: -6.01788420897818 4.0120563596928 0.85139670226739
   0:
   0:
   p 0
   1
   -1: 263
   -3: -6.01644787714157 4.03028465964146 0.851280195142494
   0:
   0:
   p 0
   1
   -1: 264
   -3: -6.01522534197473 4.04592387502193 0.85117973524784
   0:
   0:
   p 0
   1
   -1: 265
   -3: -6.01418095733804 4.05935803431702 0.851093138028338
   0:
   0:
   p 0
   1
   -1: 266
   -3: -6.01328650595625 4.07090894035215 0.851018495036276
   0:
   0:
   p 0
   1
   -1: 267
   -3: -6.01251908833889 4.08084806694036 0.850954148615188
   0:
   0:
   p 0
   1
   -1: 268
   -3: -6.01185979343929 4.08940554368011 0.850898669499098
   0:
   0:
   p 0
   1
   -1: 269
   -3: -6.01129282873027 4.09677714366745 0.850850822890925
   0:
   0:
   p 0
   1
   -1: 270
   -3: -6.01080488204811 4.10312987932953 0.850809554639626
   0:
   0:
   p 0
   1
   -1: 271
   -3: -6.01038468466455 4.10860650916209 0.850773952419938
   0:
   0:
   p 0
   1
   -1: 272
   -3: -6.01002264824528 4.11332926246206 0.850743232185278
   0:
   0:
   p 0
   1
   -1: 273
   -3: -6.0097105950702 4.11740295470542 0.850716721864889
   0:
   0:
   p 0
   1
   -1: 274
   -3: -6.00944153600374 4.12091754186174 0.850693838421003
   0:
   0:
   p 0
   1
   -1: 275
   -3: -6.00920947737737 4.12395033210577 0.850674087572101
   0:
   0:
   p 0
   1
   -1: 276
   -3: -6.00900928554381 4.12656778131553 0.850657035609255
   0:
   0:
   p 0
   1
   -1: 277
   -3: -6.00883654858407 4.12882707882864 0.850642313298872
   0:
   0:
   p 0
   1
   -1: 278
   -3: -6.008687475773 4.13077745904276 0.850629601345551
   0:
   0:
   p 0
   1
   -1: 279
   -3: -6.00855880646735 4.13246132971237 0.850618624466908
   0:
   0:
   p 0
   1
   -1: 280
   -3: -6.00844773421976 4.13391523374726 0.850609145298163
   0:
   0:
   p 0
   1
   -1: 281
   -3: -6.00835184220959 4.13517067128618 0.850600959066513
   0:
   0:
   p 0
   1
   -1: 282
   -3: -6.00826904818787 4.13625480363412 0.850593889064454
   0:
   0:
   p 0
   1
   -1: 283
   -3: -6.00819755745922 4.13719105717761 0.850587782847024
   0:
   0:
   p 0
   1
   -1: 284
   -3: -6.00813582269576 4.13799964148804 0.850582508851484
   0:
   0:
   p 0
   1
   -1: 285
   -3: -6.00808250946204 4.13869799441829 0.850577953519393
   0:
   0:
   p 0
   1
   -1: 286
   -3: -6.00803646664431 4.13930116475001 0.85057401882141
   0:
   0:
   p 0
   1
   -1: 287
   -3: -6.00799670105981 4.13982214137069 0.850570620125244
   0:
   0:
   p 0
   1
   -1: 288
   -3: -6.0079623556374 4.14027213662139 0.850567684358355
   0:
   0:
   p 0
   1
   -1: 289
   -3: -6.00793269065142 4.14066083031286 0.850565148424278
   0:
   0:
   p 0
   1
   -1: 290
   -3: -6.00790706757232 4.14099657996313 0.850562957837079
   0:
   0:
   p 0
   1
   -1: 291
   -3: -6.0078849351609 4.14128660199852 0.850561065543639
   0:
   0:
   p 0
   1
   -1: 292
   -3: -6.00786581748989 4.141537127978 0.850559430907674
   0:
   0:
   p 0
   1
   -1: 293
   -3: -6.00784930362037 4.1417535393207 0.85055801883316
   0:
   0:
   p 0
   1
   -1: 294
   -3: -6.00783503870213 4.14194048352337 0.850556799007862
   0:
   0:
   p 0
   1
   -1: 295
   -3: -6.00782271629943 4.14210197442827 0.850555745250457
   0:
   0:
   p 0
   1
   -1: 296
   -3: -6.0078120717716 4.14224147874994 0.850554834946936
   0:
   0:
   p 0
   1
   -1: 297
   -3: -6.00780287656204 4.14236199075203 0.850554048564088
   0:
   0:
   p 0
   1
   -1: 298
   -3: -6.00779493327051 4.14246609670707 0.850553369229432
   0:
   0:
   p 0
   1
   -1: 299
   -3: -6.00778807139993 4.14255603054255 0.850552782368539
   0:
   0:
   p 0
   1
   -1: 300
   -3: -6.00778214368567 4.14263372188427 0.850552275391833
   0:
   0:
   p 0
   1
   -1: 301
   -3: -6.00777702292652 4.14270083753747 0.850551837424136
   0:
   0:
   p 0
   1
   -1: 302
   -3: -6.00777259924904 4.14275881730733 0.850551459071093
   0:
   0:
   p 0
   1
   -1: 303
   -3: -6.00776877774501 4.14280890492978 0.850551132217468
   0:
   0:
   p 0
   1
   -1: 304
   -3: -6.00776547643211 4.1428521747849 0.850550849852908
   0:
   0:
   p 0
   1
   -1: 305
   -3: -6.00776262449216 4.14288955496648 0.850550605921487
   0:
   0:
   p 0
   1
   -1: 306
   -3: -6.00776016075049 4.14292184720763 0.850550395191705
   0:
   0:
   p 0
   1
   -1: 307
   -3: -6.00775803236171 4.14294974409013 0.850550213144259
   0:
   0:
   p 0
   1
   -1: 308
   -3: -6.00775619367572 4.14297384390826 0.850550055875045
   0:
   0:
   p 0
   1
   -1: 309
   -3: -6.00775460525731 4.1429946635085 0.850549920011408
   0:
   0:
   p 0
   1
   -1: 310
   -3: -6.00775323303997 4.14301264937894 0.850549802639796
   0:
   0:
   p 0
   1
   -1: 311
   -3: -6.00775204759499 4.14302818722888 0.850549701243241
   0:
   0:
   p 0
   1
   -1: 312
   -3: -6.00775102349963 4.14304161026394 0.850549613647383
   0:
   0:
   p 0
   1
   -1: 313
   -3: -6.00775013879199 4.1430532063338 0.850549537973822
   0:
   0:
   p 0
   1
   -1: 314
   -3: -6.00774937449964 4.14306322410645 0.850549472599838
   0:
   0:
   p 0
   1
   -1: 315
   -3: -6.00774871423269 4.14307187840232 0.850549416123585
   0:
   0:
   p 0
   1
   -1: 316
   -3: -6.00774814383225 4.14307935480177 0.850549367334017
   0:
   0:
   p 0
   1
   -1: 317
   -3: -6.00774765106671 4.14308581362531 0.850549325184928
   0:
   0:
   p 0
   1
   -1: 318
   -3: -6.00774722536916 4.143091393372 0.850549288772517
   0:
   0:
   p 0
   1
   -1: 319
   -3: -6.00774685761131 4.14309621368961 0.850549257315984
   0:
   0:
   p 0
   1
   -1: 320
   -3: -6.00774653990706 4.14310037794097 0.850549230140812
   0:
   0:
   p 0
   1
   -1: 321
   -3: -6.00774626544388 4.14310397542054 0.850549206664282
   0:
   0:
   p 0
   1
   -1: 322
   -3: -6.00774602833629 4.1431070832688 0.850549186382997
   0:
   0:
   p 0
   1
   -1: 323
   -3: -6.00774582350004 4.14310976812682 0.850549168862069
   0:
   0:
   p 0
   1
   -1: 324
   -3: -6.00774564654286 4.14311208756551 0.850549153725802
   0:
   0:
   p 0
   1
   -1: 325
   -3: -6.00774549367014 4.14311409131995 0.850549140649639
   0:
   0:
   p 0
   1
   -1: 326
   -3: -6.00774536160407 4.14311582235631 0.850549129353182
   0:
   0:
   p 0
   1
   -1: 327
   -3: -6.00774524751263 4.14311731779264 0.850549119594213
   0:
   0:
   p 0
   1
   -1: 328
   -3: -6.00774514894953 4.14311860969483 0.850549111163468
   0:
   0:
   p 0
   1
   -1: 329
   -3: -6.00774506380113 4.14311972576473 0.85054910388018
   0:
   0:
   p 0
   1
   -1: 330
   -3: -6.00774499024175 4.14312068993391 0.850549097588169
   0:
   0:
   p 0
   1
   -1: 331
   -3: -6.00774492669402 4.14312152287654 0.850549092152522
   0:
   0:
   p 0
   1
   -1: 332
   -3: -6.00774487179543 4.14312224245286 0.850549087456681
   0:
   0:
   p 0
   1
   -1: 333
   -3: -6.00774482436865 4.14312286409257 0.850549083399962
   0:
   0:
   p 0
   1
   -1: 334
   -3: -6.00774478339684 4.14312340112516 0.850549079895372
   0:
   0:
   p 0
   1
   -1: 335
   -3: -6.00774474800141 4.14312386506576 0.850549076867771
   0:
   0:
   p 0
   1
   -1: 336
   -3: -6.00774471742343 4.1431242658627 0.850549074252234
   0:
   0:
   p 0
   1
   -1: 337
   -3: -6.00774469100715 4.1431246121098 0.850549071992684
   0:
   0:
   p 0
   1
   -1: 338
   -3: -6.00774466818631 4.14312491123181 0.850549070040658
   0:
   0:
   p 0
   1
   -1: 339
   -3: -6.00774464847142 4.1431251696423 0.850549068354311
   0:
   0:
   p 0
   1
   -1: 340
   -3: -6.00774463143974 4.14312539288243 0.850549066897484
   0:
   0:
   p 0
   1
   -1: 341
   -3: -6.00774461672609 4.14312558573878 0.850549065638937
   0:
   0:
   p 0
   1
   -1: 342
   -3: -6.00774460401509 4.1431257523468 0.850549064551679
   0:
   0:
   p 0
   1
   -1: 343
   -3: -6.00774459303404 4.14312589627886 0.850549063612403
   0:
   0:
   p 0
   1
   -1: 344
   -3: -6.0077445835476 4.14312602062125 0.850549062800964
   0:
   0:
   p 0
   1
   -1: 345
   -3: -6.00774457535237 4.14312612804027 0.850549062099961
   0:
   0:
   p 0
   1
   -1: 346
   -3: -6.00774456827242 4.14312622083945 0.850549061494369
   0:
   0:
   p 0
   1
   -1: 347
   -3: -6.00774456215608 4.14312630100823 0.850549060971202
   0:
   0:
   p 0
   1
   -1: 348
   -3: -6.00774455687225 4.14312637026589 0.850549060519235
   0:
   0:
   p 0
   1
   -1: 349
   -3: -6.00774455230751 4.14312643009735 0.850549060128786
   0:
   0:
   p 0
   1
   -1: 350
   -3: -6.00774454836405 4.1431264817856 0.850549059791477
   0:
   0:
   p 0
   1
   -1: 351
   -3: -6.0077445449573 4.14312652643874 0.850549059500079
   0:
   0:
   p 0
   1
   -1: 352
   -3: -6.00774454201426 4.14312656501466 0.850549059248337
   0:
   0:
   p 0
   1
   -1: 353
   -3: -6.00774453947177 4.14312659834013 0.85054905903086
   0:
   0:
   p 0
   1
   -1: 354
   -3: -6.00774453727532 4.14312662713 0.850549058842981
   0:
   0:
   p 0
   1
   -1: 355
   -3: -6.0077445353778 4.14312665200144 0.850549058680674
   0:
   0:
   p 0
   1
   -1: 356
   -3: -6.00774453373856 4.14312667348772 0.850549058540458
   0:
   0:
   p 0
   1
   -1: 357
   -3: -6.00774453232243 4.14312669204962 0.850549058419325
   0:
   0:
   p 0
   1
   -1: 358
   -3: -6.00774453109903 4.14312670808524 0.850549058314679
   0:
   0:
   p 0
   1
   -1: 359
   -3: -6.00774453004213 4.14312672193842 0.850549058224275
   0:
   0:
   p 0
   1
   -1: 360
   -3: -6.00774452912906 4.14312673390608 0.850549058146178
   0:
   0:
   p 0
   1
   -1: 361
   -3: -6.00774452834033 4.14312674424513 0.850549058078703
   0:
   0:
   p 0
   1
   -1: 362
   -3: -6.00774452765887 4.14312675317705 0.850549058020416
   0:
   0:
   p 0
   1
   -1: 363
   -3: -6.00774452707016 4.14312676089327 0.850549057970061
   0:
   0:
   p 0
   1
   -1: 364
   -3: -6.00774452656161 4.14312676755922 0.85054905792656
   0:
   0:
   p 0
   1
   -1: 365
   -3: -6.0077445261223 4.14312677331791 0.850549057888978
   0:
   0:
   p 0
   1
   -1: 366
   -3: -6.00774452574273 4.14312677829275 0.850549057856514
   0:
   0:
   p 0
   1
   -1: 367
   -3: -6.00774452541481 4.14312678259067 0.850549057828467
   0:
   0:
   p 0
   1
   -1: 368
   -3: -6.00774452513154 4.1431267863035 0.850549057804238
   0:
   0:
   p 0
   1
   -1: 369
   -3: -6.00774452488682 4.14312678951114 0.850549057783306
   0:
   0:
   p 0
   1
   -1: 370
   -3: -6.00774452467542 4.14312679228196 0.850549057765224
   0:
   0:
   p 0
   1
   -1: 371
   -3: -6.00774452449274 4.14312679467572 0.850549057749606
   0:
   0:
   p 0
   1
   -1: 372
   -3: -6.00774452433497 4.14312679674361 0.850549057736111
   0:
   0:
   p 0
   1
   -1: 373
   -3: -6.00774452419868 4.14312679853006 0.850549057724453
   0:
   0:
   p 0
   1
   -1: 374
   -3: -6.00774452408092 4.14312680007345 0.850549057714381
   0:
   0:
   p 0
   1
   -1: 375
   -3: -6.00774452397918 4.14312680140681 0.850549057705681
   0:
   0:
   p 0
   1
   -1: 376
   -3: -6.00774452389131 4.14312680255857 0.850549057698164
   0:
   0:
   p 0
   1
   -1: 377
   -3: -6.00774452381538 4.14312680355373 0.85054905769167
   0:
   0:
   p 0
   1
   -1: 378
   -3: -6.00774452374981 4.14312680441335 0.85054905768606
   0:
   0:
   p 0
   1
   -1: 379
   -3: -6.00774452369317 4.14312680515591 0.850549057681214
   0:
   0:
   p 0
   1
   -1: 380
   -3: -6.00774452364418 4.14312680579742 0.85054905767703
   0:
   0:
   p 0
   1
   -1: 381
   -3: -6.00774452360193 4.14312680635166 0.850549057673411
   0:
   0:
   p 0
   1
   -1: 382
   -3: -6.00774452356541 4.14312680683049 0.850549057670285
   0:
   0:
   p 0
   1
   -1: 383
   -3: -6.00774452353381 4.14312680724416 0.850549057667589
   0:
   0:
   p 0
   1
   -1: 384
   -3: -6.00774452350657 4.1431268076015 0.850549057665255
   0:
   0:
   p 0
   1
   -1: 385
   -3: -6.00774452348303 4.14312680790999 0.850549057663243
   0:
   0:
   p 0
   1
   -1: 386
   -3: -6.00774452346267 4.14312680817683 0.850549057661501
   0:
   0:
   p 0
   1
   -1: 387
   -3: -6.0077445234451 4.14312680840709 0.850549057659999
   0:
   0:
   p 0
   1
   -1: 388
   -3: -6.00774452342991 4.14312680860621 0.850549057658699
   0:
   0:
   p 0
   1
   -1: 389
   -3: -6.00774452341682 4.14312680877809 0.850549057657576
   0:
   0:
   p 0
   1
   -1: 390
   -3: -6.00774452340547 4.14312680892679 0.850549057656606
   0:
   0:
   p 0
   1
   -1: 391
   -3: -6.00774452339568 4.14312680905525 0.850549057655768
   0:
   0:
   p 0
   1
   -1: 392
   -3: -6.00774452338722 4.14312680916614 0.850549057655044
   0:
   0:
   p 0
   1
   -1: 393
   -3: -6.0077445233799 4.14312680926201 0.850549057654418
   0:
   0:
   p 0
   1
   -1: 394
   -3: -6.00774452337357 4.14312680934479 0.850549057653878
   0:
   0:
   p 0
   1
   -1: 395
   -3: -6.00774452336813 4.14312680941627 0.850549057653411
   0:
   0:
   p 0
   1
   -1: 396
   -3: -6.00774452336344 4.14312680947799 0.850549057653008
   0:
   0:
   p 0
   1
   -1: 397
   -3: -6.00774452335937 4.14312680953134 0.85054905765266
   0:
   0:
   p 0
   1
   -1: 398
   -3: -6.00774452335583 4.14312680957736 0.850549057652361
   0:
   0:
   p 0
   1
   -1: 399
   -3: -6.0077445233528 4.14312680961722 0.8505490576521
   0:
   0:
   p 0
   1
   -1: 400
   -3: -6.00774452335014 4.14312680965155 0.850549057651878
   0:
   0:
   p 0
   1
   -1: 401
   -3: -6.00774452334791 4.14312680968116 0.850549057651684
   0:
   0:
   p 0
   1
   -1: 402
   -3: -6.00774452334594 4.14312680970688 0.850549057651516
   0:
   0:
   p 0
   1
   -1: 403
   -3: -6.00774452334427 4.14312680972905 0.85054905765137
   0:
   0:
   p 0
   1
   -1: 404
   -3: -6.00774452334282 4.14312680974815 0.850549057651245
   0:
   0:
   p 0
   1
   -1: 405
   -3: -6.00774452334155 4.14312680976467 0.850549057651138
   0:
   0:
   p 0
   1
   -1: 406
   -3: -6.00774452334046 4.14312680977891 0.850549057651045
   0:
   0:
   p 0
   1
   -1: 407
   -3: -6.00774452333949 4.14312680979123 0.850549057650966
   0:
   0:
   p 0
   1
   -1: 408
   -3: -6.00774452333871 4.14312680980174 0.850549057650897
   0:
   0:
   p 0
   1
   -1: 409
   -3: -6.00774452333801 4.14312680981092 0.850549057650836
   0:
   0:
   p 0
   1
   -1: 410
   -3: -6.00774452333737 4.14312680981897 0.850549057650785
   0:
   0:
   p 0
   1
   -1: 411
   -3: -6.00774452333686 4.14312680982581 0.85054905765074
   0:
   0:
   p 0
   1
   -1: 412
   -3: -6.00774452333644 4.14312680983169 0.850549057650701
   0:
   0:
   p 0
   1
   -1: 413
   -3: -6.00774452333603 4.14312680983693 0.850549057650666
   0:
   0:
   p 0
   1
   -1: 414
   -3: -6.00774452333568 4.14312680984147 0.850549057650637
   0:
   0:
   p 0
   1
   -1: 415
   -3: -6.00774452333538 4.14312680984536 0.850549057650612
   0:
   0:
   p 0
   1
   -1: 416
   -3: -6.00774452333513 4.14312680984853 0.850549057650591
   0:
   0:
   p 0
   1
   -1: 417
   -3: -6.00774452333492 4.14312680985144 0.850549057650572
   0:
   0:
   p 0
   1
   -1: 418
   -3: -6.00774452333474 4.14312680985394 0.850549057650555
   0:
   0:
   p 0
   1
   -1: 419
   -3: -6.00774452333457 4.14312680985615 0.850549057650541
   0:
   0:
   p 0
   1
   -1: 420
   -3: -6.00774452333443 4.14312680985802 0.850549057650528
   0:
   0:
   p 0
   1
   -1: 421
   -3: -6.00774452333426 4.14312680985961 0.85054905765052
   0:
   0:
   p 0
   1
   -1: 422
   -3: -6.00774452333417 4.14312680986089 0.850549057650512
   0:
   0:
   p 0
   1
   -1: 423
   -3: -6.00774452333409 4.14312680986202 0.850549057650504
   0:
   0:
   p 0
   1
   -1: 424
   -3: -6.00774452333402 4.14312680986309 0.850549057650497
   0:
   0:
   p 0
   1
   -1: 425
   -3: -6.00774452333395 4.14312680986404 0.85054905765049
   0:
   0:
   p 0
   1
   -1: 426
   -3: -6.0077445233339 4.14312680986478 0.850549057650485
   0:
   0:
   p 0
   1
   -1: 427
   -3: -6.00774452333385 4.14312680986556 0.850549057650479
   0:
   0:
   p 0
   1
   -1: 428
   -3: -6.00774452333382 4.14312680986607 0.850549057650476
   0:
   0:
   p 0
   1
   -1: 429
   -3: -6.00774452333377 4.14312680986669 0.850549057650472
   0:
   0:
   p 0
   1
   -1: 430
   -3: -6.00774452333374 4.14312680986721 0.850549057650469
   0:
   0:
   p 0
   1
   -1: 431
   -3: -6.0077445233337 4.14312680986759 0.850549057650466
   0:
   0:
   p 0
   1
   -1: 432
   -3: -6.00774452333366 4.14312680986795 0.850549057650464
   0:
   0:
   p 0
   1
   -1: 433
   -3: -6.00774452333365 4.14312680986807 0.850549057650463
   0:
   0:
   p 0
   1
   -1: 434
   -3: -6.00774452333363 4.14312680986841 0.850549057650461
   0:
   0:
   p 0
   1
   -1: 435
   -3: -6.0077445233336 4.14312680986853 0.850549057650461
   0:
   0:
   p 0
   1
   -1: 436
   -3: -6.00774452333361 4.14312680986876 0.850549057650459
   0:
   0:
   p 0
   1
   -1: 437
   -3: -6.00774452333359 4.14312680986889 0.850549057650458
   0:
   0:
   p 0
   1
   -1: 438
   -3: -6.00774452333353 4.14312680986897 0.85054905765046
   0:
   0:
   p 0
   1
   -1: 439
   -3: -6.00774452333355 4.14312680986913 0.850549057650458
   0:
   0:
   p 0
   1
   -1: 440
   -3: -6.00774452333355 4.14312680986931 0.850549057650456
   0:
   0:
   p 0
   1
   -1: 441
   -3: -6.00774452333355 4.14312680986961 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 442
   -3: -6.00774452333355 4.14312680986958 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 443
   -3: -6.00774452333353 4.14312680986973 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 444
   -3: -6.00774452333354 4.14312680986968 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 445
   -3: -6.00774452333353 4.14312680986978 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 446
   -3: -6.00774452333349 4.1431268098698 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 447
   -3: -6.00774452333347 4.14312680986975 0.850549057650455
   0:
   0:
   p 0
   1
   -1: 448
   -3: -6.0077445233335 4.14312680986974 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 449
   -3: -6.00774452333354 4.14312680986964 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 450
   -3: -6.00774452333355 4.14312680986967 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 451
   -3: -6.00774452333353 4.14312680986981 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 452
   -3: -6.00774452333353 4.14312680986979 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 453
   -3: -6.00774452333352 4.1431268098698 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 454
   -3: -6.00774452333352 4.14312680986986 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 455
   -3: -6.00774452333353 4.14312680986979 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 456
   -3: -6.00774452333354 4.14312680986979 0.850549057650451
   0:
   0:
   p 0
   1
   -1: 457
   -3: -6.00774452333352 4.14312680986975 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 458
   -3: -6.00774452333353 4.14312680986979 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 459
   -3: -6.0077445233335 4.14312680986988 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 460
   -3: -6.00774452333351 4.14312680986988 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 461
   -3: -6.00774452333352 4.14312680986986 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 462
   -3: -6.00774452333352 4.14312680986971 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 463
   -3: -6.00774452333352 4.14312680986975 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 464
   -3: -6.00774452333352 4.14312680986986 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 465
   -3: -6.00774452333354 4.14312680986978 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 466
   -3: -6.00774452333355 4.14312680986972 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 467
   -3: -6.00774452333352 4.14312680986979 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 468
   -3: -6.00774452333352 4.1431268098697 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 469
   -3: -6.00774452333354 4.14312680986962 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 470
   -3: -6.00774452333355 4.1431268098696 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 471
   -3: -6.00774452333353 4.14312680986964 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 472
   -3: -6.00774452333353 4.14312680986961 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 473
   -3: -6.00774452333354 4.1431268098696 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 474
   -3: -6.00774452333354 4.14312680986956 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 475
   -3: -6.00774452333352 4.14312680986952 0.850549057650455
   0:
   0:
   p 0
   1
   -1: 476
   -3: -6.00774452333353 4.14312680986938 0.850549057650456
   0:
   0:
   p 0
   1
   -1: 477
   -3: -6.00774452333355 4.1431268098693 0.850549057650456
   0:
   0:
   p 0
   1
   -1: 478
   -3: -6.00774452333357 4.14312680986918 0.850549057650456
   0:
   0:
   p 0
   1
   -1: 479
   -3: -6.00774452333356 4.1431268098693 0.850549057650455
   0:
   0:
   p 0
   1
   -1: 480
   -3: -6.00774452333354 4.1431268098695 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 481
   -3: -6.00774452333355 4.14312680986966 0.850549057650452
   0:
   0:
   p 0
   1
   -1: 482
   -3: -6.00774452333355 4.14312680986976 0.850549057650451
   0:
   0:
   p 0
   1
   -1: 483
   -3: -6.00774452333348 4.14312680986987 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 484
   -3: -6.00774452333346 4.14312680986962 0.850549057650457
   0:
   0:
   p 0
   1
   -1: 485
   -3: -6.0077445233335 4.1431268098697 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 486
   -3: -6.00774452333354 4.1431268098697 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 487
   -3: -6.00774452333352 4.14312680986961 0.850549057650454
   0:
   0:
   p 0
   1
   -1: 488
   -3: -6.00774452333354 4.14312680986963 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 489
   -3: -6.00774452333354 4.14312680986969 0.850549057650453
   0:
   0:
   p 0
   1
   -1: 490
   -3: -6.00774452333353 4.14312680986962 0.850549057650454
   0:
   0:
   p 1
   msg=Last point
   bif=0
   1
   -1: 491
   -3: -6.00774452333352 4.14312680986972 0.850549057650453
   -7: 1.167 0.2 0.01 2 1
     4 0.1
   0:
   -
   a=2
   1
    c=1, u=0
    1:
    (-1000,3,-1) (-1000,2,-1) (-1000,2,0)
   1
    c=1, u=0
    1:
    (-1000,3,-1) (-1000,2,-1) (-1000,2,0)
   t=1
    494 1
    6: 491 -6.00774452333352 4.14312680986972 0.850549057650453 492
     1000
    0:
   b=0
   m=-1,-1
   slvpar=0
  e -
&
